import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;
import java.awt.event.*;
import java.awt.Graphics2D.* ;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;
import javax.swing.border.*;
import java.awt.Color.*;
import javax.swing.plaf.*;
import java.util.*;
import java.awt.image.*;
import java.awt.image.Raster.*;
import javax.swing.text.*;
import java.lang.String.*;

//***********************************************************************

class nubj_linea extends nubj

//***********************************************************************
{
  Color c;
  int x0,y0,x1,y1;
  int esy=1180;
  double teta1 =0;
  int n, ikk=0, nn=0;
  double m=0,m1=0,mp1=0,mp=0,h0,h1,r,h01,h11;
  nubj_punto mipunto, mpunto;
  nubj_mpcircle micir;
  nubj_oval moval;
  nubj_punto mipunto1, mipunto2;
  nubj_punto mypunto, mypunt;
  nubj_linea mylin, myli, lin1, lin2, carga, viga;

  nubj_linea(int xx0,int yy0,Color cc,nubj_list p)
  {
    super(p);
    x0 = x1 = xmin = xmax = xx0;
    y0 = y1 = ymin = ymax = yy0;
    n = 2;
    nombre="li";
    select = 3;
  }
  
  nubj_linea(nubj_linea l1, nubj_linea l2, int h, nubj_list p)
    {
	super(p);
	//	carga = l1;
	//	viga = l2;
		if(l1.xd[0]==l1.xd[1]) carga = l1; else carga = l2;
		if(carga==l1) viga=l2; else viga=l1;
	nn=h;
	n=2;
	nombre="li";
	select=3;
    }


  nubj_linea(nubj_punto poin, nubj_linea recta, nubj_list p)
  {
    super(p);
    mypunto = poin;
    mylin = recta;
    nombre="li";
    select=3;
    n=2;
  }
  
  nubj_linea(nubj_punto poi, nubj_linea rect, int h, nubj_list p)
  {
    super(p);
    mypunt = poi;
    myli = rect;
    nn = h;
    nombre="li";
    select=3;
    n=2;
  }
  
  
  nubj_linea(nubj_punto pointe, nubj_punto pun, nubj_list p)
    {
	super(p);
	mipunto1 = pointe;
	mipunto2 = pun;
	n=2;
	nombre="li";
	select=3;
    }

  nubj_linea(nubj_linea l1, nubj_linea l2, nubj_list p)
    {
	super(p);
	lin1 = l1;
	lin2 = l2;
	n=2;
	nombre="li";
	select=3;
    }

  nubj_linea(nubj_punto poin, nubj_mpcircle cir, nubj_list p)
    {
	super(p);
	mipunto = poin;
	n=2;
	micir = cir;
        nombre="li";
	select=3;
    }

  nubj_linea(nubj_punto poi, nubj_mpcircle circ,int h, nubj_list p)
    {
	super(p);
	mipunto = poi;
	n=2;
	micir = circ;
        nombre="li";
	nn=h;
	select=3;
    }
  
  nubj_linea(nubj_punto mp1, nubj_oval o1, int h, nubj_list p)
    {
	super(p);
	mpunto = mp1;
	n=2;
	moval = o1;
	nn = h;
        nombre="li";
	select=3;
    }


    public void transform(double xc, double yc, double zc)
    {
	ikk=1;
	modi(xc,yc,zc,n);
	x0=(int)xd[0];
	x1=(int)xd[1];
	y0=(int)yd[0];
	y1=(int)yd[1];
    }

    public void paint(Graphics g) 
    {
	c = cc;
	Graphics2D g2 = (Graphics2D) g ;
	CSD = false;

	if(mylin!=null)
	  {
	xd[0]=mypunto.xd[0]; yd[0]=mypunto.yd[0];
	xd[2]=mylin.xd[0];yd[2]=mylin.yd[0];
	xd[3]=mylin.xd[1];yd[3]=mylin.yd[1];
	xc = (xd[0]+xd[1])/2;
	yc = (yd[0]+yd[1])/2;
	zc = (zd[0]+zd[1])/2;
	if((xd[2]!=xd[3]) && (yd[2]!=yd[3]))
	    {
		m = (yd[3]-yd[2])/(xd[3]-xd[2]);
		mp = -1./m;
		h0=yd[2]-m*xd[2];
		h1=yd[0]-mp*xd[0];
		xd[1]=(h0-h1)/(mp-m); yd[1]=m*xd[1]+h0;
	    }
	else if((xd[2]!=xd[3]) && (yd[2]==yd[3]))
	  {
	    xd[1]=xd[0];
	    yd[1]=yd[2];
	  }
	else if((xd[2]==xd[3]) && (yd[2]!=yd[3]))
	  {
	    xd[1]=xd[2];
	    yd[1]=yd[0];
	  }
	x0=(int)xd[0];y0=(int)yd[0];x1=(int)xd[1];y1=(int)yd[1];
	  }

	if(micir!=null)
	  {
	xd[0]=mipunto.xd[0]; yd[0]=mipunto.yd[0];
	xd[2]=micir.xd[0];yd[2]=micir.yd[0];
	r=micir.R1;
	double beta = Math.atan((yd[2]-yd[0])/(xd[2]-xd[0]));
	double dist = Math.sqrt((xd[2]-xd[0])*(xd[2]-xd[0])+(yd[2]-yd[0])*(yd[2]-yd[0]));
	double alfa = Math.asin(r/dist);
	if(nn==0)teta1 = beta+alfa;
	if(nn==1)teta1 = beta-alfa;
	double mp = Math.tan(teta1);
	if(mp==0)mp=0.000001;
	m = -1/mp;
	h0 = yd[2]-m*xd[2];
	h1=yd[0]-mp*xd[0];
	xd[1]=(h0-h1)/(mp-m); yd[1]=m*xd[1]+h0;
	x0=(int)xd[0];y0=(int)yd[0];x1=(int)xd[1];y1=(int)yd[1];
	  }

	if(lin1!=null)
	  {
	    double m1 = (lin1.yd[1]-lin1.yd[0])/(lin1.xd[1]-lin1.xd[0]);
	    double m2 = (lin2.yd[1]-lin2.yd[0])/(lin2.xd[1]-lin2.xd[0]);
	    double alfa = Math.atan(m1);
	    double beta = Math.atan(m2);
	    double m = Math.tan((alfa+beta)/2.);
	    double h0 = lin1.yd[0]-m1*lin1.xd[0];
	    double h1 = lin2.yd[0]-m2*lin2.xd[0];
	    xd[0] = (h1-h0)/(m1-m2); yd[0] = m1*xd[0]+h0;
	    double h = yd[0]-m*xd[0];
	    xd[1]=(lin1.xd[1]+lin2.xd[1])/2.;
	    yd[1]=m*xd[1]+h;
	    x0=(int)xd[0];y0=(int)yd[0];x1=(int)xd[1];y1=(int)yd[1];
	  }

	if(moval!=null)
	  {
	    xd[0] = mpunto.xd[0]; yd[0] = mpunto.yd[0];
	    double a = ((double)moval.x1-(double)moval.x0)/2.;
	    double b = ((double)moval.y1-(double)moval.y0)/2.;
	    double xc = (double)moval.x0+a;
	    double yc = (double)moval.y0+b;
	    double aa = b*b*(xd[0]-xc);
	    double bb = a*a*(yd[0]-yc);
	    double cc = -b*b*xc*(xd[0]-xc)-a*a*yc*(yd[0]-yc)-a*a*b*b;
	    double d = -aa/bb; double f=-cc/bb-yc;
	    double e = b*b+a*a*d*d;
	    double u = (2*a*a*d*f-2*b*b*xc)/e;
	    double v = (b*b*xc*xc+a*a*f*f-a*a*b*b)/e;
	    double w = Math.sqrt(u*u-4.*v);
	    if(nn==1)xd[1]=(-u+w)/2.;
	    if(nn==2)xd[1]=(-u-w)/2.; 
	    yd[1]=d*xd[1]-cc/bb;
	    x0=(int)xd[0];y0=(int)yd[0];x1=(int)xd[1];y1=(int)yd[1];
	  }

	if(nn==2 && moval==null && carga==null)
	  {
	    xd[0]=mypunt.xd[0];yd[0]=mypunt.yd[0];
	    xd[1]=(myli.xd[0]+myli.xd[1])/2.;
	    yd[1]=(myli.yd[0]+myli.yd[1])/2.;
	    x0=(int)xd[0];y0=(int)yd[0];x1=(int)xd[1];y1=(int)yd[1];
	  }

	if(mipunto1!=null)
	  {
	xd[0]=mipunto1.xd[0]; yd[0]=mipunto1.yd[0];
	xd[1]=mipunto2.xd[0]; yd[1]=mipunto2.yd[0];
	x0=(int)xd[0];y0=(int)yd[0];x1=(int)xd[1];y1=(int)yd[1];
	  }


	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	if(linea!=0)stroke = new BasicStroke(strokeThickness,BasicStroke.CAP_BUTT,BasicStroke.JOIN_MITER,10.0f,dash,0.0f);
	g2.setStroke(stroke);

	if(ikk==0){xd[0]=(double)x0;xd[1]=(double)x1;yd[0]=(double)y0;yd[1]=(double)y1;}
	setminmax();
	xc = (xd[0]+xd[1])/2;
	yc = (yd[0]+yd[1])/2;
	zc = (zd[0]+zd[1])/2;
	int x = (int)xd[0];
	int y = (int)yd[0];
	if(x>(int)xd[1]) x = (int)xd[1];
	if(y>(int)yd[1]) y = (int)yd[1];


	if(select!=0)
      	    {
		g.setColor(Color.red);
		g2.draw(new Line2D.Double(xd[0],yd[0],xd[1],yd[1]));
		g.fillRect((int)xd[0]-1,(int)yd[0]-1,3,3);
		g.fillRect((int)xd[1]-1,(int)yd[1]-1,3,3);
	    }
	else
	    {
		g.setColor(cl);
		g2.draw(new Line2D.Double(xd[0],yd[0],xd[1],yd[1]));
		if(putarr == true)
		    {
		g.setColor(Color.blue);
			if((numarr/10)%10 == 1 && numarr%10 != 2) g.fillRect((int)xd[1]-1,(int)yd[1]-1,3,3);
			if(numarr%10 == 2) g.fillRect((int)xd[0]-1,(int)yd[0]-1,3,3);
			if((numarr/10)%10 == 2) 
			    {
				g.fillRect((int)xd[0]-1,(int)yd[0]-1,3,3);
				g.fillRect((int)xd[1]-1,(int)yd[1]-1,3,3);
			    }
		    }
		g.setColor(cl);
		x0=(int)xd[0];x1=(int)xd[1];y0=(int)yd[0];y1=(int)yd[1];
		//		g.fillRect((int)xd[1]-1,(int)yd[1]-1,3,3);
	    }
	      stroke = new BasicStroke(0.5f);
	      g2.setStroke(stroke);
	g.setColor(cl);
    }

    public void metapost(BufferedWriter out) 
    {
	try 
	    {
		float rc = (float) cl.getRed()/255f;
		float vc = (float) cl.getGreen()/255f;
		float ac = (float) cl.getBlue()/255f;
		float esy0 = 1180f - (float)(yd[0]/uesc);
		float esy1 = 1180f - (float)(yd[1]/uesc);
		drw = "draw";
		if(putarr == true)
		    {
			if((numarr/100000) == 1) out.write("input fl_metap.mp;\n");
			if((numarr/100000) == 2) out.write("input fl_pstri.mp;\n");
			if((numarr/100000) == 3) out.write("input fl_simple.mp;\n");
			if((numarr/100000) == 4) out.write("input fl_open.mp;\n");
			if((numarr/100000) == 5) out.write("input fl_ugly.mp;\n");
			if((numarr/100000) == 6) out.write("input fl_guindi.mp;\n");
			if((numarr/10000)%10 == 1) out.write("ahlength:= 3 pt;\n");
		        if((numarr/10000)%10 == 2)out.write("ahlength:= 5 pt;\n");
		       	if((numarr/10000)%10 == 3)out.write("ahlength:= 7 pt;\n");
       		        if((numarr/10000)%10 == 4)out.write("ahlength:= 9 pt;\n");
	      		if((numarr/10000)%10 == 5)out.write("ahlength:= 13 pt;\n");
	      		if((numarr/10000)%10 == 6)out.write("ahlength:= 25 pt;\n");
			if((numarr/1000)%10 == 1) out.write("ahangle:= 20;\n");
			if((numarr/1000)%10 == 2) out.write("ahangle:= 30;\n");
			if((numarr/1000)%10 == 3) out.write("ahangle:= 45;\n");
			if((numarr/1000)%10 == 4) out.write("ahangle:= 60;\n");
			if((numarr/1000)%10 == 5) out.write("ahangle:= 75;\n");
			if((numarr/1000)%10 == 6) out.write("ahangle:= 90;\n");
			if((numarr/100)%10 == 1) out.write("linejoin:= rounded;\n");
			if((numarr/100)%10 == 2) out.write("linejoin:= mitered;\n");
			if((numarr)%10 == 1 && filar==false) drw = "drawarrow";
			if((numarr)%10 == 2 && filar==false) drw = "drawarrow reverse";
			if((numarr/10)%10 == 2 && filar==false) drw = "drawdblarrow";
			if((numarr)%10 == 1 && filar==true) drw = "drawwhitearrow";
			if((numarr)%10 == 2 && filar==true) drw = "drawwhitearrow reverse";
			if((numarr/10)%10 == 2 && filar==true) drw = "drawdblwharrow";
		    
		    }
	        out.write("pickup pencircle scaled "+thickness+";\npath a;\n");
			out.write ("loc:=("+rc+","+vc+","+ac+");\n");
			out.write("a:= ("+(float)(xd[0]/uesc)+"u,"+(float)esy0+"u)--("+(float)(xd[1]/uesc)+"u,"+esy1+"u);\n") ;
			out.write(drw+" a withcolor loc "); 
			if(linea!=0)out.write(tipo_linea);
			else out.write(";\n");
	    }
	catch (IOException ex) { }
    }

    public void setminmax()
    {
	xmin = 2000;
	ymin = 2000;
	xmax = -2000;
	ymax = -2000;
	zmax = -2000;
	zmin = 2000;
	for(int i=0;i<2;i++)

	    {
		if(xd[i]<(double)xmin) xmin = (int)xd[i]  ;
		if(yd[i]<(double)ymin) ymin = (int)yd[i]  ;
		if(xd[i]>(double)xmax) xmax = (int)(xd[i]+.99)  ;
		if(yd[i]>(double)ymax) ymax = (int)(yd[i]+.99)  ;
		if(zd[i]<(double)zmin) zmin = (int)zd[i]  ;
		if(zd[i]>(double)zmax) zmax = (int)(zd[i]+.99)  ;
	    }
    }

    public void moveobj(int xx,int yy)
    {
	x0 += xx; xd[0] += (double)xx;
	y0 += yy; yd[0] += (double)yy;
	x1 += xx; xd[1] += (double)xx;
	y1 += yy; yd[1] += (double)yy;
	setminmax();
    }
    public void movepoint(int x,int y)
    {
	if(select==3){ x1 += x;y1 += y; xd[1] += (double)x; yd[1] += (double)y;}
	if(select==2){ x0 += x;y0 += y; xd[0] += (double)x; yd[0] += (double)y;}
	setminmax();
    }

    public boolean selectpoint(int xx,int yy)
    {
	if(xx-(int)xd[0]<3 && xx-(int)xd[0]>-3 && yy-(int)yd[0]<3 && yy-yd[0]>-3)
	    {
		select = 2;
		return(true);
	    }
	if(xx-(int)xd[1]<3 && xx-(int)xd[1]>-3 && yy-(int)yd[1]<3 && yy-yd[1]>-3)
	    {
		select = 3;
		return(true);
	    }
	return(false);
    }
   
    public boolean selectobj(int xx,int yy)
    {
	setminmax();
	if(xx>=xmin && xx<=xmax && yy>=ymin && yy<=ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }
    
    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	setminmax();
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		setminmax();
		select = 1;
		return(true);
	    }
	return(false);
    }
}
