import java.io.*;
import java.lang.String.*;
import java.util.*;
import java.awt.*;
import java.awt.Cursor.*;
import java.awt.event.*;
import java.awt.event.KeyEvent.*;
import java.awt.geom.*;
import java.awt.Color.*;
import java.awt.image.*;
import java.awt.datatransfer.*;
import javax.swing.*;
import javax.swing.border.*;
import javax.swing.event.*;
import javax.swing.plaf.*;
import javax.swing.text.*;
import javax.swing.text.rtf.*;
import javax.swing.filechooser.*;


//***********************************************************************

class nubj_punto extends nubj

//***********************************************************************
{
  Color c;
  int x0,y0,x1,y1,ikk=0, nn=0;
  nubj_mpcircle micir;
  nubj_linea milin, mili0, mili1, mili;
  nubj_line mimi;
  nubj_oval mioval;

  nubj_punto(nubj_oval cir, nubj_linea poin, int h, nubj_list p)
    {
	super(p);
	mili = poin;
	mioval = cir;
        nombre="pu";
	select=5;
	nn=h;
    }


    nubj_punto(int xx0,int yy0,Color cc,nubj_list p)
    {
	super(p);
	xd[0] = xd[1] = (double)xx0;
	yd[0] = yd[1] = (double)yy0;
	x0 = xmin = xmax = xx0;
	y0 = ymin = ymax = yy0;
	c = cc;
	nombre="pu";
	select = 5;
    }

  nubj_punto(double ax, double ay,Color cc, nubj_list p)
  {
    super(p);
    cl = cc;
    xd[0] = ax; yd[0] = ay;
  }

  nubj_punto(nubj_mpcircle mpci, nubj_linea recta, nubj_list p)
    {
        super(p);
	micir = mpci;
	milin = recta;
	nombre="pu";
	select = 5;
    }

  nubj_punto(nubj_linea rec1, nubj_linea recta, nubj_list p)
    {
        super(p);
	mili0 = rec1;
	mili1 = recta;
	nombre="pu";
	select = 5;
    }

  nubj_punto(nubj_line re, nubj_linea recta, nubj_list p)
    {
        super(p);
	mimi = re;
	mili1 = recta;
	nombre="pu";
	select = 5;
    }

  nubj_punto(nubj_mpcircle mpci, nubj_linea recta, int h, nubj_list p)
    {
        super(p);
	micir = mpci;
	milin = recta;
	nn=h;
	nombre="pu";
	select = 5;
    }

    public nubj copy(nubj_list gl)
    {
	nubj_punto g;
	g = new nubj_punto(x0,y0,c,gl);
	g.movepoint(x1-x0,y1-y0);
	g.select = 0;
	return(g);
    
    }

    public void transform(double xc, double yc, double zc)
    {
	int n=1;
	ikk=1;
	if(value!=0)
	    modi(xc,yc,zc,n);
    }

    public void paint(Graphics g) 
    {
	Graphics2D g2 = (Graphics2D) g ;
	CSD = false;

	if(milin!=null)
	  {
	xd[3]=milin.xd[0]; yd[3]=milin.yd[0];
	xd[4]=milin.xd[1]; yd[4]=milin.yd[1];
	xd[2]=micir.xd[0];yd[2]=micir.yd[0];
	double rad = micir.R1;
	double m = (yd[4]-yd[3])/(xd[4]-xd[3]);
	double h0=yd[3]-m*xd[3];
	double ado = h0-yd[2];
	double bdo = (2.*xd[2]-2.*m*ado)/(1.+m*m);
	double cdo = (xd[2]*xd[2]+ado*ado-rad*rad)/(1+m*m);
	double ddo = Math.sqrt(bdo*bdo-4.*cdo);
	if(nn==0)xd[0] = (bdo+ddo)/2.; 
	if(nn==1)xd[0] = (bdo-ddo)/2.;
	yd[0]=m*xd[0]+h0;
	  }

	if(mili0!=null)
	  {
	    double m0, m1, h0, h1;
	    if(mili0.xd[1]==mili0.xd[0])
	      {
		xd[0] = mili0.xd[0];
		m1 = (mili1.yd[1]-mili1.yd[0])/(mili1.xd[1]-mili1.xd[0]);
		h1 = mili1.yd[0]-m1*mili1.xd[0];
		yd[0] = m1*xd[0]+h1;
	      }
	    else if(mili1.xd[1]==mili1.xd[0])
	      {
		xd[0] = mili1.xd[0];
		m0 = (mili0.yd[1]-mili0.yd[0])/(mili0.xd[1]-mili0.xd[0]);
		h0 = mili0.yd[0]-m0*mili0.xd[0];
		yd[0] = m0*xd[0]+h0;
	      }
	    else
	      {
		m0 = (mili0.yd[1]-mili0.yd[0])/(mili0.xd[1]-mili0.xd[0]);
		m1 = (mili1.yd[1]-mili1.yd[0])/(mili1.xd[1]-mili1.xd[0]);
		h0 = mili0.yd[0]-m0*mili0.xd[0];
		h1 = mili1.yd[0]-m1*mili1.xd[0];
		xd[0] = (h1-h0)/(m0-m1);
		yd[0] = m0*xd[0]+h0;
	      }
	  }

	if(mimi!=null)
	  {
	    double m0, m1, h0, h1;
	    if(mimi.xd[1]==mimi.xd[0])
	      {
		xd[0] = mimi.xd[0];
		m1 = (mili1.yd[1]-mili1.yd[0])/(mili1.xd[1]-mili1.xd[0]);
		h1 = mili1.yd[0]-m1*mili1.xd[0];
		yd[0] = m1*xd[0]+h1;
	      }
	    else if(mili1.xd[1]==mili1.xd[0])
	      {
		xd[0] = mili1.xd[0];
		m0 = (mimi.yd[1]-mimi.yd[0])/(mimi.xd[1]-mimi.xd[0]);
		h0 = mimi.yd[0]-m0*mimi.xd[0];
		yd[0] = m0*xd[0]+h0;
	      }
	    else
	      {
		m0 = (mimi.yd[1]-mimi.yd[0])/(mimi.xd[1]-mimi.xd[0]);
		m1 = (mili1.yd[1]-mili1.yd[0])/(mili1.xd[1]-mili1.xd[0]);
		h0 = mimi.yd[0]-m0*mimi.xd[0];
		h1 = mili1.yd[0]-m1*mili1.xd[0];
		xd[0] = (h1-h0)/(m0-m1);
		yd[0] = m0*xd[0]+h0;
	      }
	  }

	if(mioval!=null)
	  {
	    double a = ((double)mioval.w/2.)*((double)mioval.w/2.);
	    double b = ((double)mioval.h/2.)*((double)mioval.h/2.);
	    double m = (mili.yd[1]-mili.yd[0])/(mili.xd[1]-mili.xd[0]);
	    double h = mili.yd[0]-m*mili.xd[0];
	    double xc = (mioval.xd[1]+mioval.xd[0])/2.;
	    double yc = (mioval.yd[1]+mioval.yd[0])/2.;
	    double c = h-yc;
	    double d = b+a*m*m;
	    double bb = (2.*a*m*c-2.*b*xc)/d;
	    double cc = (b*xc*xc+a*c*c-a*b)/d;
	    double dd = Math.sqrt(bb*bb-4.*cc);
	    if((m<=0 && nn==1) || (m>0 && nn==2))xd[0] = (-bb-dd)/2.;
	    if((m>0 && nn==1) || (m<=0 && nn==2))xd[0] = (-bb+dd)/2.;
	    yd[0] = m*xd[0]+h;
	  }


	x0=(int)xd[0];
	y0=(int)yd[0];
	xc = xd[0];
	yc = yd[0];
	zc = zd[0];
	int x = x0;
	int y = y0;
	int w = 3;
	int h = 3;

	float rc = (float) cl.getRed()/255f;
	float vc = (float) cl.getGreen()/255f;
	float ac = (float) cl.getBlue()/255f;

	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);
	g2.setColor(cl);
	 
	if(select!=0)
	    {
		g2.setColor(Color.red);
		g2.fillRect(x0-1,y0-1,3,3);
		g.drawOval((x0-4),(y0-4), 2*4, 2*4);
	    }
	else 
	    {
		g2.setColor(cl);
		g2.fillRect(x0-1,y0-1,3,3);
		//		g.drawOval((x0-4),(y0-4), 2*4, 2*4);
	    }
	stroke = new BasicStroke(0.5f);
	g2.setStroke(stroke);
	g2.setColor(cl);
    }

    public void metapost(BufferedWriter out) 
    {
	float sy0 = 1180f-(float)(yd[0]/uesc);
	float xm0 = (float)(xd[0]/uesc);
	float th = thickness;
	float cr=0f, cv=0f, ca=0f;
	if(c!=null)
	    {
		cr = (float) c.getRed()/255f;
		cv = (float) c.getGreen()/255f;
		ca = (float) c.getBlue()/255f;
	    }
	float rc = (float) cl.getRed()/255f;
	float vc = (float) cl.getGreen()/255f;
	float ac = (float) cl.getBlue()/255f;
		try 
		    {
			if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0)
			    {
					out.write ("loc:= ("+rc+","+vc+","+ac+");\n");
					out.write ("pickup pencircle scaled "+th+";\ndraw("+xm0+"u,"+sy0+"u) withcolor loc;\n");
			    }       	
		else out.write ("pickup pencircle scaled "+th+";\ndraw("+xm0+"u,"+sy0+"u);\n");
	    }
	catch (IOException ex) { }
    }

    public void moveobj(int x,int y)
    {
	x0 += x; xd[0] += (double)x;
	y0 += y; yd[0] += (double)y;
	xmin=x0-5; ymin=y0-5;
	xmax=x0+5; ymax=y0+5;
    }

    public void movepoint(int x,int y)
    {
	x0 += x; xd[0] += (double)x;
	y0 += y; yd[0] += (double)y;
	xmin=x0-5; ymin=y0-5;
	xmax=x0+5; ymax=y0+5;
    }

    public boolean selectpoint(int x,int y)
    {
	if(((x+5)>x0 && (x-5)<x0) && ((y+5)>y0 && (y-5)<y0)) 
	    {
		select = 2;
		return(true);
	    }  
	return(false);
    }

    public boolean selectobj(int x,int y)
    {
      if(((x+5)>x0 && (x-5)<x0) && ((y+5)>y0 && (y-5)<y0))
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<x0 && xx1>x0 && yy0<y0 && yy1>y0)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }
}
