import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;
import java.awt.event.*;
import java.awt.Graphics2D.* ;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;
import javax.swing.border.*;
import java.awt.Color.*;
import javax.swing.plaf.*;
import java.util.*;
import java.awt.image.*;
import java.awt.image.Raster.*;
import javax.swing.text.*;
import java.lang.String.*;

//**************************************************************************

class nubj_rect extends nubj

//**************************************************************************
{
    Color c;
    int x0,y0,x1,y1,ijk=0;

    nubj_rect(int xx0,int yy0,Color cc,nubj_list p)
    {
	super(p);
	c = cc;
	x0 = x1 = xmin = xmax = xx0;
	y0 = y1 = ymin = ymax = yy0;
	select = 5;
    }

    nubj_rect(int xx0,int yy0,int xx1,int yy1,Color cc,nubj_list p)
    {
	super(p);
	c = cc;
	x0 =  xmin = xx0;
	y0 = ymin = yy0;
	x1 =  xmax = xx1;
	y1 =  ymax = yy1;
	select = 5;
    }

    public void transform(double xc, double yc, double zc)
    {
	if(value!=10)ijk=ijk+1;
	if(value!=0)
	    modi(xc,yc,zc,4);
	x0=(int)xd[0];
	x1=(int)xd[1];
	y0=(int)yd[0];
	y1=(int)yd[1];
    }

    public void paint(Graphics g) 
    {
	Graphics2D g2 = (Graphics2D) g ;
	CSD = false;
	int x = x0;
	int y = y0;
	int w = x1-x0;
	int h = y1-y0;
	if(x>x1) x = x1;
	if(y>y1) y = y1;
	if(w<0) w = -w;
	if(h<0) h = -h;
	if(ijk==0){
	xd[0]=(double)x0;yd[0]=(double)y0;xd[1]=(double)x1;yd[1]=(double)y1;
	xd[2]=xd[0];yd[2]=yd[1];xd[3]=xd[1];yd[3]=yd[0];}
	xc = (xd[0]+xd[1])/2;
	yc = (yd[0]+yd[1])/2;
	zc = (zd[0]+zd[1])/2;
	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	GeneralPath rectan = new GeneralPath();
	rectan.moveTo((float)xd[0],(float)yd[0]);
	rectan.lineTo((float)xd[3],(float)yd[3]);	
	rectan.lineTo((float)xd[1],(float)yd[1]);	
	rectan.lineTo((float)xd[2],(float)yd[2]);	
	rectan.closePath();
	forma[0] = (Shape) rectan; 
	if (select != 0)
	{
	    g2.setColor(Color.red);
	    stroke = new BasicStroke(0.5f);
	    g2.setStroke(stroke);
	    if(ijk==0)
		{
		    g2.drawRect(x,y,w,h);
		    g2.fillRect(x-1,y-1,3,3);
		    g2.fillRect(x+w-1,y-1,3,3);
		    g2.fillRect(x-1,y+h-1,3,3);
		    g2.fillRect(x+w-1,y+h-1,3,3);
		}
	    else if (ijk!=0) g2.draw(forma[0]);
	}

	if (select == 0 )
	    {
		stroke = new BasicStroke(thickness);
		g2.setStroke(stroke);
		if(refill==1)
		    {
			g2.setColor(cc); 
			g2.fill(forma[0]);
		    }
		g2.setColor(cl);
		g2.draw(forma[0]);
	    }
	      stroke = new BasicStroke(0.5f);
	      g2.setStroke(stroke);
	g2.setColor(cl);
    }
    
    public void metapost(BufferedWriter out) 
    {
	c=cc;
	float rc = (float) cl.getRed()/255f;
	float vc = (float) cl.getGreen()/255f;
	float ac = (float) cl.getBlue()/255f;
	for(int i=0; i<4; i++){xd[i]=xd[i]; yd[i]=yd[i]; }
   	try {
	    float sy0 = 1180f-(float)(yd[0]/uesc);float sy2 = 1180f - (float)(yd[2]/uesc);
	    float sy1 = 1180f - (float)(yd[1]/uesc);float sy3 = 1180f - (float)(yd[3]/uesc);
	    float xm0 = (float)(xd[0]/uesc);float xm1 = (float)(xd[1]/uesc);
	    float xm2 = (float)(xd[2]/uesc);float xm3 = (float)(xd[3]/uesc);
	    out.write ("pickup pencircle scaled "+thickness+";\n");
	    if(refill==1)
		{
		    float cr = (float) c.getRed()/255f;
		    float cv = (float) c.getGreen()/255f;
		    float ca = (float) c.getBlue()/255f;
		    out.write ("col:=("+cr+","+cv+","+ca+");\n"); 
		    out.write ("filldraw ("+xm0+"u,"+sy0+"u)--("+xm3+"u,"+sy3+"u)--("+xm1+"u,"+sy1+"u)--("+xm2+"u,"+sy2+"u)--cycle withcolor col;\n");
		}
	    if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0)
		{ 
		    out.write ("loc:=("+rc+","+vc+","+ac+");\n");  
		    out.write ("draw ("+xm0+"u,"+sy0+"u)--("+xm3+"u,"+sy3+"u)--("+xm1+"u,"+sy1+"u)--("+xm2+"u,"+sy2+"u)--("+xm0+"u,"+sy0+"u)--cycle withcolor loc ");
		}
	    else out.write ("draw ("+xm0+"u,"+sy0+"u)--("+xm3+"u,"+sy3+"u)--("+xm1+"u,"+sy1+"u)--("+xm2+"u,"+sy2+"u)--("+xm0+"u,"+sy0+"u)--cycle ");
	    {
		if(linea!=0)out.write(tipo_linea);
		else out.write(";\n");
	    }
	}
	catch (IOException ex) { }
    }
    
    public void moveobj(int x,int y)
    {
	if(ijk==0)
	    {
		for(int i=0;i<4;i++)
		    {
			xd[i]+=(double)x;
			yd[i]+=(double)y; }
		x1 += x;
		x0 += x;
		y1 += y;
		y0 += y;
		if(x0<x1) { xmin = x0-2 ; xmax = x1+2 ; }
		else      { xmin = x1-2 ; xmax = x0+2 ; }
		if(y0<y1) { ymin = y0-2 ; ymax = y1+2 ; }
		else      { ymin = y1-2 ; ymax = y0+2 ; }
	    }
	if(ijk!=0)
	    {
		xmin=2000;xmax=-2000;ymin=2000;ymax=-2000;
		for(int i=0;i<4;i++)
		    {
			xd[i]+=(double)x;
			yd[i]+=(double)y;                       
			if(xmin>(int)xd[i]-1) xmin=(int)xd[i]-1;
			if(xmax<(int)xd[i]+1) xmax=(int)xd[i]+1;
			if(ymin>(int)yd[i]-1) ymin=(int)yd[i]-1;
			if(ymax<(int)yd[i]+1) ymax=(int)yd[i]+1;
		    }
	    }
    }

    public void movepoint(int x,int y)
    {
	if(ijk==0)
	    {
		if(select==5 || select==3)
		    x1 += x;
		if(select==4 || select==2)
		    x0 += x;
		if(select==5 || select==4)
		    y1 += y;
		if(select==3 || select==2)
		    y0 += y;
		if(x0<x1) { xmin = x0 ; xmax = x1 ; }
		else      { xmin = x1 ; xmax = x0 ; }
		if(y0<y1) { ymin = y0 ; ymax = y1 ; }
		else      { ymin = y1 ; ymax = y0 ; }
	    }
    }

    public boolean selectpoint(int x,int y)
    {
	if(x-x0<3 && x-x0>-3 && y-y0<3 && y-y0>-3)
	    {
		select = 2;
		return(true);
	    }
	if(x-x1<3 && x-x1>-3 && y-y0<3 && y-y0>-3)
	    {
		select = 3;
		return(true);
	    }
	if(x-x0<3 && x-x0>-3 && y-y1<3 && y-y1>-3)
	    {
		select = 4;
		return(true);
	    }
	else if(x-x1<3 && x-x1>-3 && y-y1<3 && y-y1>-3)
	    {
		select = 5;
		return(true);
	    }
	return(false);
    }

    public boolean selectobj(int x,int y)
    {
	if(x>=xmin && x<=xmax && y>=ymin && y<=ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }
}
