import java.awt.*;
import java.awt.event.*;
import java.io.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.geom.*;
import java.awt.Color.*;
import javax.swing.event.*;
import javax.swing.plaf.*;
import java.util.*;

public class chooseTxppar extends JFrame implements ActionListener
{
    public JTextField datos;
    Color col = new Color(0,0,150);
    String dat="", aa="";
    int dt=0;
    float par[] = new float[11];

    drawpaper parent;
    
    public chooseTxppar()
    {
	super ("TXP Parameter Adjuster");
	getContentPane().setLayout(new BorderLayout(1,1));
	getContentPane().setSize(360,60);
	addWindowListener(new BasicWindowMonitor());
	par[1]=1;
	par[2]=1;
	par[3]=0;
	par[4]=1;
	par[5]=-3;
	par[6]=0;
	par[7]=0;
	par[8]=0;
	par[9]=1;
	par[10]=0;

	JPanel abajo = new JPanel();
	abajo.setLayout(new GridLayout(1,3));
	abajo.setBorder(new BevelBorder(BevelBorder.RAISED));
	abajo.setSize(360,20);
	JLabel der = new JLabel(" 2-Click a button");
	JLabel izq = new JLabel(" 1-Input the data");
	datos = new JTextField(4);
	datos.setBorder(new BevelBorder(BevelBorder.LOWERED));
	abajo.add(izq);
	abajo.add(datos);
	abajo.add(der);

	JPanel botones = new JPanel();
	botones.setLayout(new GridLayout(1,10));
	botones.setSize(360,20);
	JRadioButton bot1 = new JRadioButton("XS",false);
	bot1.addActionListener(this);
	bot1.setToolTipText("Choose the X-Scale of the Glyphs. Default=1.0");
	JRadioButton bot2 = new JRadioButton("YS",false);
	bot2.addActionListener(this);
	bot2.setToolTipText("Choose the Y-Scale of the Glyphs. Default=1.0");
	JRadioButton bot3 = new JRadioButton("SL",false);
	bot3.addActionListener(this);
	bot3.setToolTipText("Choose the Slanted Grade of the Glyphs. Default=0.0");
	JRadioButton bot4 = new JRadioButton("PS",false);
	bot4.addActionListener(this);
	bot4.setToolTipText("Choose the Scale for the Path. Default=1.0");
	JRadioButton bot5 = new JRadioButton("HL",false);
	bot5.addActionListener(this);
	bot5.setToolTipText("Choose the Placements of the Glyphs over the curve. Default=-3.");
	JRadioButton bot6 = new JRadioButton("SB",false);
	bot6.addActionListener(this);
	bot6.setToolTipText("Choose the Space from the begining of the Curve. Default=0.");
	JRadioButton bot7 = new JRadioButton("SG",false);
	bot7.addActionListener(this);
	bot7.setToolTipText("Choose the Space between the Glyphs. Default=0. Recommended: between 0 and 0.5");
	JRadioButton bot8 = new JRadioButton("CG",false);
	bot8.addActionListener(this);
	bot8.setToolTipText("Choose the Color of the Glyphs: Default:Black=0;  Red=1, Green=2, Blue=3.");
	JRadioButton bot9 = new JRadioButton("CL",false);
	bot9.addActionListener(this);
	bot9.setToolTipText("Choose the Color of the Curve. Default:Red=1; Black=0, Green=2, Blue=3.");
	JRadioButton bot10 = new JRadioButton("TH",false);
	bot10.addActionListener(this);
	bot10.setToolTipText("Choose the Thickness of the curve. Recommended between 0 and 2. Default:No Curve=0");

	botones.add(bot1);
	botones.add(bot2);
	botones.add(bot3);
	botones.add(bot4);
	botones.add(bot5);
	botones.add(bot6);
	botones.add(bot7);
	//	botones.add(bot8);
	botones.add(bot9);
	botones.add(bot10);

	ButtonGroup grup = new ButtonGroup();
	grup.add(bot10);
	grup.add(bot9);
	//grup.add(bot8);
	grup.add(bot7);
	grup.add(bot6);
	grup.add(bot5);
	grup.add(bot4);
	grup.add(bot3);
	grup.add(bot2);
	grup.add(bot1);

	JPanel arriba = new JPanel();
	arriba.setSize(360,40);
	arriba.setBorder(new BevelBorder(BevelBorder.RAISED));
	JLabel tit = new JLabel("        C U R V E D   T E X T    P A R A M E T E R S  ");
	arriba.add(tit);

	getContentPane().add("North",arriba);
	getContentPane().add("Center",botones);
	getContentPane().add("South",abajo);

	pack();

    }

    public void actionPerformed(ActionEvent event) 
    {
		dat = event.getActionCommand();
	
		if(dat=="XS")
		    {
			dt=1;
			aa=datos.getText();
			par[1] = Float.parseFloat(aa);
			datos.setText("1.0");
		    }
		if(dat=="YS") 
		    {
			dt=2;
			aa=datos.getText();
			par[2] = Float.parseFloat(aa);
			datos.setText("0.0");
		    }
		if(dat=="SL") 
		    {
			dt=3;
			aa=datos.getText();
			par[3] = Float.parseFloat(aa);
			datos.setText("1.0");
		    }
		if(dat=="PS") 
		    {
			dt=4;
			aa=datos.getText();
			par[4] = Float.parseFloat(aa);
			datos.setText("-3.0");
		    }
		if(dat=="HL") 
		    {
			dt=5;
			aa=datos.getText();
			par[5] = Float.parseFloat(aa);
			datos.setText("0.0");
		    }
		if(dat=="SB") 
		    {
			dt=6;
			aa=datos.getText();
			par[6] = Float.parseFloat(aa);
			datos.setText("0.0");
		    }
		
		if(dat=="SG") 
		    {
			dt=7;
			aa=datos.getText();
			par[7] = Float.parseFloat(aa);
			datos.setText("1.0");
		    }

		if(dat=="CL") 
		    {
			dt=9;
			aa=datos.getText();
			par[9] = Float.parseFloat(aa);
			datos.setText("0.0");
		    }
		if(dat=="TH") 
		    {
			dt=10;
			aa=datos.getText();
			par[10] = Float.parseFloat(aa);
		    }
    }


    public float[] newparam()
    {
	return(par);
    }    
}

