import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;
import java.awt.event.*;
import java.awt.Graphics2D.* ;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;
import javax.swing.border.*;
import java.awt.Color.*;
import javax.swing.plaf.*;
import java.util.*;
import java.awt.image.*;
import java.awt.image.Raster.*;
import javax.swing.text.*;
import java.lang.String.*;

//***********************************************************************

class nubj_circle extends nubj

//***********************************************************************
{
    Color c;
    int n,i,ikk=0,stat=5,x0_old,y0_old, x0, y0, x1, y1;
    double r2,r;
    double dumxd[] = new double[64]; double dumyd[] = new double[64];
    
    nubj_circle(int xx0,int yy0,Color cc,nubj_list p)
    {
	super(p);
	x0 = x1 = xmin = xmax = xx0;
	y0 = y1 = ymin = ymax = yy0;
	select = 2;
	//	c=cc;
    }

    public void transform(double xc, double yc, double zc)
    {
	n=12;
        ikk = 1;
	modi(xc,yc,zc,n);
    }

    public void paint(Graphics g) 
    {
	c=cc;
	Graphics2D g2 = (Graphics2D) g ;
	Ellipse2D.Double elipse;
	CSD = false;
	float strokeThickness = thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);
	g.setColor(cl);
	for(int i=0;i<12;i++){
	    dumxd[i]=xd[i]; dumyd[i]=yd[i];}
	    if(value==0 && ikk==0)
	    {	
		r=Math.sqrt((x1-x0)*(x1-x0)+(y1-y0)*(y1-y0));
		r2 = 0.5528*r ;

		xd[0]=x0+r;xd[1]=xd[0];xd[2]=xd[0]-(r-r2);xd[3]=xd[0]-r;xd[4]=xd[3]-r2;
		xd[5]=xd[3]-r; xd[6]=xd[5]; xd[7]=xd[5]; xd[8]=xd[4]; xd[9]=xd[3];
		xd[10]=xd[2]; xd[11]=xd[0];
		yd[0]=y0; yd[1]=yd[0]+r2; yd[2]=yd[0]+r; yd[3]=yd[2]; yd[4]=yd[2];
		yd[5]=yd[1]; yd[6]=yd[0]; yd[7]=yd[0]-r2; yd[8]=yd[0]-r;
		yd[9]=yd[8]; yd[10]=yd[8]; yd[11]=yd[7];
	    }
	else 
	    {
		if(x0_old!=x0 || y0_old!=y0)
		    {
	       for(int i=0;i<12;i++){
		   xd[i]=dumxd[i]+(double)(x0-x0_old); yd[i]=dumyd[i]+(double)(y0-y0_old);
	       }
		    }
		else
		    {
		for(int i=0;i<12;i++){
		    xd[i]=dumxd[i]; yd[i]=dumyd[i];}
		    }
	    }
	setminmax();
	xc=(xmax+xmin)/2; yc=(ymax+ymin)/2; zc=(zmax+zmin)/2;
	g2.setColor(cl) ;

    GeneralPath circulo = new GeneralPath();
    circulo.moveTo((float)xd[0],(float)yd[0]);
    circulo.curveTo((float)xd[1],(float)yd[1],(float)xd[2],(float)yd[2],(float)xd[3],(float)yd[3]);
    circulo.curveTo((float)xd[4],(float)yd[4],(float)xd[5],(float)yd[5],(float)xd[6],(float)yd[6]);
    circulo.curveTo((float)xd[7],(float)yd[7],(float)xd[8],(float)yd[8],(float)xd[9],(float)yd[9]);
    circulo.curveTo((float)xd[10],(float)yd[10],(float)xd[11],(float)yd[11],(float)xd[0],(float)yd[0]);
	forma[2] = (Shape) circulo;
 
       	if(select!=0)
	    {
		g2.setColor(Color.red);
		stroke = new BasicStroke(0.5f);
		g2.setStroke(stroke);
		Ellipse2D eli2=new Ellipse2D.Double(xc-2,yc-2,5,5);
		g2.fill(eli2);
		Ellipse2D eli3=new Ellipse2D.Double(xd[0]-4,yd[0]-2,5,5);
		g2.fill(eli3);
		n=12;
	    }
	if(select==0 && refill==1)
	    { 
		stroke = new BasicStroke(thickness);
		g2.setStroke(stroke);
		g2.setColor(cc); 
		g2.fill(forma[2]);
	    }
	if(select!=0)g2.setColor(Color.red);
	else g2.setColor(cl);
	g2.draw(forma[2]);
	stroke = new BasicStroke(0.5f);
	g2.setStroke(stroke);
	x0_old=x0; y0_old=y0;
    }
    
    
    public void metapost(BufferedWriter out) 
    {
	float cr=0f, cv=0f, ca=0f, rc=0f, vc=0f, ac=0f;
	if(c!=null)
	    {
		cr = (float)c.getRed()/255f;
		cv = (float)c.getGreen()/255f;
		ca = (float)c.getBlue()/255f;
	    }
	rc = (float)cl.getRed()/255f;
	vc = (float)cl.getGreen()/255f;
	ac = (float)cl.getBlue()/255f;
	xd[12]=xd[0]; yd[12]=yd[0];
	try 
	    {
		if(refill==1) out.write ("col:= ("+cr+","+cv+","+ca+");\n");
		out.write ("loc:=("+rc+","+vc+","+ac+");\n");
		out.write("pickup pencircle scaled "+thickness+";\npath a;\na:=");
		for(i=0;i<12;i+=3)
		    out.write("("+(xd[i]/uesc)+"u,"+1180+"u-"+(yd[i]/uesc)+"u).. controls ("+(xd[i+1]/uesc)+"u,"+1180+"u-"+(yd[i+1]/uesc)+"u) and ("+(xd[i+2]/uesc)+"u, "+1180+"u-"+(yd[i+2]/uesc)+"u)..("+(xd[i+3]/uesc)+"u, "+1180+"u-"+(yd[i+3]/uesc)+"u)..");
		out.write(" cycle;\n");
		if(text_on_path==false)
		    {
			if(refill==1) out.write( "fill a withcolor col;\n" ); 
       			if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0)
			    {
				out.write("draw a withcolor loc ");
				if(linea!=0)out.write(tipo_linea);
				else out.write(";\n");
				}
			else
			    {
				out.write("draw a withcolor loc ");
				if(linea!=0)out.write(tipo_linea);
				else out.write(";\n");
			    }
		    }
		if(text_on_path==true)
		    {
			String colorli="black";
			if(partx[9]==1.0)colorli="red";
			if(partx[9]==2.0)colorli="green";
			if(partx[9]==3.0)colorli="blue";
			out.write("xscal:="+partx[1]+"; yscal:="+partx[2]+"; slan:="+partx[3]+"; scafig:="+partx[4]+"; hy:="+partx[5]+"; tt:="+partx[6]+"; sep:="+partx[7]+"; llc:="+colorli+"; lin:="+partx[10]+";\n");
			out.write("txp(ss,a,xscal,yscal,slan,scafig,hy,tt,sep,col,llc,lin,alt);\n");
		    }

	    }
	catch (IOException ex) { }            
    }


    public void setminmax()
    {
	xmin = 1000;
	ymin = 1000;
	xmax = -1000;
	ymax = -1000;
	zmax = -1000;
	zmin = 1000;
	for(int i=0;i<12;i++)

	    {
		if(xd[i]<(double)xmin) xmin = (int)xd[i]  ;
		if(yd[i]<(double)ymin) ymin = (int)yd[i]  ;
		if(xd[i]>(double)xmax) xmax = (int)(xd[i]+.99)  ;
		if(yd[i]>(double)ymax) ymax = (int)(yd[i]+.99)  ;
		if(zd[i]<(double)zmin) zmin = (int)zd[i]  ;
		if(zd[i]>(double)zmax) zmax = (int)(zd[i]+.99)  ;
	    }
    }

    public void moveobj(int xx,int yy)
    {
		x0 += xx;
		y0 += yy;
		x1 += xx;
		y1 += yy;
	setminmax();
    }

    public void movepoint(int x,int y)
    {
		if(ikk==0 && select>0)
		    {
			x1 += x;
			y1 += y;
		    }
		if(x0<x1) {xmin = x0 ; xmax = x1 ; }
		else      {xmin = x1 ; xmax = x0 ; }
		if(y0<y1) {ymin = y0 ; ymax = y1 ; }
		else      {ymin = y1 ; ymax = y0 ; }
		
		if(select>0 && ikk>0)
		    {
			double relx = (xd[0]+x-xc)/(xd[0]-xc);
			for(int i=0;i<12;i++)
			    {
				xd[i] = (xd[i]-xc)*relx + xc;
				yd[i] = (yd[i]-yc)*relx + yc;
			    }
		    }
    }
    
    public boolean selectpoint(int xx,int yy)
    {
	if(xx-(int)xd[0]<3 && xx-(int)xd[0]>-3 && yy-(int)yd[0]<3 && yy-yd[0]>-3)
	    {
		select = 2;
		return(true);
	    }
	return(false);
    }
   
    public boolean selectobj(int xx,int yy)
    {
	setminmax();
	if(xx>=xmin && xx<=xmax && yy>=ymin && yy<=ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }
    
    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	setminmax();
	if(xx0<xd[6] && xx1>xd[0] && yy0<yd[9] && yy1>yd[3])
	    {
		setminmax();
		select = 1;
		return(true);
	    }
	return(false);
    }

    public boolean done()
    {
	if(n==13)
	    {
		n--;
		return(true);
	    }
	return(false);
    }
}

