import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;
import java.awt.event.*;
import java.awt.Graphics2D.* ;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;
import javax.swing.border.*;
import java.awt.Color.*;
import javax.swing.plaf.*;
import java.util.*;
import java.awt.image.*;
import java.awt.image.Raster.*;
import javax.swing.text.*;
import java.lang.String.*;

//********************************************************************

class nubj_qbrd extends nubj

//********************************************************************
{
    Color c;
    int n, ikk=0;
    double xd[] = new double[1000];
    double yd[] = new double[1000];
    nubj_qbrd(int xx0,int yy0,Color cc,nubj_list p)
    {
	super(p);
	xg[0] = xg[1] = xmin = xmax = xx0;
	yg[0] = yg[1] = ymin = ymax = yy0;
	n = 2;
	select = 3;
    }

    nubj_qbrd(float xxg[],float yyg[],int np,Color cc,nubj_list p)
    {
	super(p);
	int i ;
        for (i=0;i<np;i++) 
	    {
		xd[i] =(double)(xxg[i]/0.708) ;
		yd[i] =(double)(yyg[i]/0.708) ;
		if (xmin > xd[i]) xmin  = (int)(xd[i]-.5) ;
		if (xmax < xd[i]) xmax  = (int)(xd[i]+.5) ;
		if (ymin > yd[i]) ymin  = (int)(yd[i]-.5) ;
		if (ymax < yd[i]) ymax  = (int)(yd[i]+.5) ;
	    }
	int yccc=1180;
        for (i=0;i<np;i++)yd[i]=yccc-yd[i];
	n = np;
	ikk=1;
	select = 1;
    }

    nubj_qbrd(double xxg[],double yyg[],int np,Color cc,nubj_list p)
    {
	super(p);
	int i ;
        for (i=0;i<np;i++) 
	    {
		xd[i] = xxg[i] ;
		yd[i] = yyg[i] ;
		xg[i] = (int)(xd[i]+0.5);
		yg[i] = (int)(yd[i]+0.5);
		if (xmin > xd[i]) xmin  = (int)(xd[i]-.5) ;
		if (xmax < xd[i]) xmax  = (int)(xd[i]+.5) ;
		if (ymin > yd[i]) ymin  = (int)(yd[i]-.5) ;
		if (ymax < yd[i]) ymax  = (int)(yd[i]+.5) ;
	    }
	n = np;
	ikk=1;
    }

    public void transform(double xc, double yc, double zc)
    {
	ikk=1;
	modi(xc,yc,zc,n);
    }

    public void paint(Graphics g) 
    {
	c=cc;
	int ik=0;
	Graphics2D g2 = (Graphics2D) g ;
	CSD = false;
	float strokeThickness = thickness;
	if(select!=0)g2.drawString("   "+thickness,843,270);
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);
	Polygon p = new Polygon();
	for(int i=0;i<n;i++)
	    p.addPoint(xg[i],yg[i]);
      	if(ikk==0)for(int i=0;i<n;i++){xd[i]=(double)xg[i];yd[i]=(double)yg[i];}
        if(ikk!=0)for(int i=0;i<n;i++){ xg[i]=(int)xd[i];yg[i]=(int)yd[i]; }
	setminmax();
	xc = (xmax+xmin)/2;
	yc = (ymax+ymin)/2;
	zc = (zmax+zmin)/2;
	if(select!=0) 
	    {
		g.setColor(Color.red);
		g.fillRect(xg[0]-1,yg[0]-1,3,3);
		stroke = new BasicStroke(0.5f);
		g2.setStroke(stroke);
		for(int i = 0;i<n-1;i++)
		    {
			g2.drawLine(xg[i],yg[i],xg[(i+1)%n],yg[(i+1)%n]);
			g.fillRect(xg[i+1]-1,yg[i+1]-1,3,3);
		    }
	    }
	if(select==0 && refill==1)
	    { 
		g2.setColor(cc); 
		g2.fillPolygon(p);
		g2.setColor(cl); 
		stroke = new BasicStroke(thickness);
		g2.setStroke(stroke);
		for(int i = 0;i<n-1;i++)
		g2.drawLine(xg[i],yg[i],xg[(i+1)%n],yg[(i+1)%n]);
	    }
	else if(select==0)
	    {
		g2.setColor(cl); 
		stroke = new BasicStroke(thickness);
		g2.setStroke(stroke);
		for(int i = 0;i<n-1;i++)
		g2.drawLine(xg[i],yg[i],xg[(i+1)%n],yg[(i+1)%n]);
	    }
	if(putarr == true)
	    {
		g.setColor(Color.blue);
		if((numarr/10)%10 == 1 && (numarr)%10 != 2) g.fillRect(xg[n-1]-1,yg[n-1]-1,3,3);
		if((numarr)%10 == 2) g.fillRect(xg[0]-1,yg[0]-1,3,3);
		if((numarr/10)%10 == 2) 
		    {
			g.fillRect(xg[0]-1,yg[0]-1,3,3);
			g.fillRect(xg[n-1]-1,yg[n-1]-1,3,3);
		    }
	    }
	g2.setColor(cl);
	      stroke = new BasicStroke(0.5f);
	      g2.setStroke(stroke);
    }

    public void metapost(BufferedWriter out) 
    {
	float cr=0f, cv=0f, ca=0f, rc=0f, vc=0f, ac=0f;
	float xmd[] = new float[512]; float ymd[] = new float[512];
	if(c!=null)
	    {
		cr = (float)c.getRed()/255f;
		cv = (float)c.getGreen()/255f;
		ca = (float)c.getBlue()/255f;
	    }
	rc = (float) cl.getRed()/255f;
	vc = (float) cl.getGreen()/255f;
	ac = (float) cl.getBlue()/255f;
	for(int i=0;i<n;i++){ ymd[i]=(float)(1180-yd[i]/uesc);xmd[i]=(float)xd[i]/uesc; }
	if(Math.abs(xmd[n-1]-xmd[0]) <=2 && Math.abs(ymd[n-1]-ymd[0]) <=2){xmd[n-1]=xmd[0]; ymd[n-1]=ymd[0];}
	try 
	    {
		if(refill==1) out.write ("col:= ("+cr+","+cv+","+ca+");\n");
		out.write ("loc:=("+rc+","+vc+","+ac+");\n");
		drw = "draw";
		if(putarr == true)
		    {
			if((numarr/100000) == 1) out.write("input fl_metap.mp;\n");
			if((numarr/100000) == 2) out.write("input fl_pstri.mp;\n");
			if((numarr/100000) == 3) out.write("input fl_simple.mp;\n");
			if((numarr/100000) == 4) out.write("input fl_open.mp;\n");
			if((numarr/100000) == 5) out.write("input fl_ugly.mp;\n");
			if((numarr/100000) == 6) out.write("input fl_guindi.mp;\n");
			if((numarr/10000)%10 == 1) out.write("ahlength:= 3 pt;\n");
		        if((numarr/10000)%10 == 2)out.write("ahlength:= 5 pt;\n");
		       	if((numarr/10000)%10 == 3)out.write("ahlength:= 7 pt;\n");
       		        if((numarr/10000)%10 == 4)out.write("ahlength:= 9 pt;\n");
	      		if((numarr/10000)%10 == 5)out.write("ahlength:= 13 pt;\n");
	      		if((numarr/10000)%10 == 6)out.write("ahlength:= 20 pt;\n");
			if((numarr/1000)%10 == 1) out.write("ahangle:= 20;\n");
			if((numarr/1000)%10 == 2) out.write("ahangle:= 30;\n");
			if((numarr/1000)%10 == 3) out.write("ahangle:= 45;\n");
			if((numarr/1000)%10 == 4) out.write("ahangle:= 60;\n");
			if((numarr/1000)%10 == 5) out.write("ahangle:= 75;\n");
			if((numarr/1000)%10 == 6) out.write("ahangle:= 90;\n");
			if((numarr/100)%10 == 1) out.write("linejoin:= rounded;\n");
			if((numarr/100)%10 == 2) out.write("linejoin:= mitered;\n");
			if((numarr)%10 == 1 && filar==false) drw = "drawarrow";
			if((numarr)%10 == 2 && filar==false) drw = "drawarrow reverse";
			if((numarr/10)%10 == 2 && filar==false) drw = "drawdblarrow";
			if((numarr)%10 == 1 && filar==true) drw = "drawwhitearrow";
			if((numarr)%10 == 2 && filar==true) drw = "drawwhitearrow reverse";
			if((numarr/10)%10 == 2 && filar==true) drw = "drawdblwharrow";
		    
		    }

		out.write("pickup pencircle scaled "+thickness+";\npath a;\na:=");
		out.write("("+xmd[0]+"u,"+ymd[0]+"u) -- ("+xmd[1]+"u,"+ymd[1]+"u)");
		for(int i=2;i<n;i++) out.write(" -- ("+xmd[i]+"u,"+ymd[i]+"u)");
		if(xmd[n-1]==xmd[0] && ymd[n-1]==ymd[0]){out.write("--cycle;\n");flag=true;}
		else out.write(";\n");
		if(refill==1 && flag!=true)out.write("path b;\nb:= a -- cycle;\n");

		if(text_on_path==false)
		    {
			if(refill==1 && flag!=true) out.write( "fill b withcolor col;\n" );
			else if(refill==1) out.write("fill a withcolor col;\n");
			if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0)
		        out.write(drw+" a withcolor loc ");
			else out.write(drw+" a ");
			if(linea!=0)out.write(tipo_linea);
			else out.write(";\n");
		    }

		if(text_on_path==true)
		    {
			String colorli="black";
			if(partx[9]==1.0)colorli="red";
			if(partx[9]==2.0)colorli="green";
			if(partx[9]==3.0)colorli="blue";
			out.write("xscal:="+partx[1]+"; yscal:="+partx[2]+"; slan:="+partx[3]+"; scafig:="+partx[4]+"; hy:="+partx[5]+"; tt:="+partx[6]+"; sep:="+partx[7]+"; llc:="+colorli+"; lin:="+partx[10]+";\n");
			out.write("txp(ss,a,xscal,yscal,slan,scafig,hy,tt,sep,col,llc,lin,alt);\n");
		    }
	    }
	catch (IOException ex) { }            
    }


    public void setminmax()
    {
	xmin = 2000;
	ymin = 2000;
	xmax = -2000;
	ymax = -2000;
	zmax = -2000;
	zmin = 2000;
	
	if(ikk==1)
	    for(int i=0;i<n;i++)
		{
		    if(xd[i]<(double)xmin) xmin = (int)xd[i]  ;
		    if(yd[i]<(double)ymin) ymin = (int)yd[i]  ;
		    if(xd[i]>(double)xmax) xmax = (int)(xd[i]+.99)  ;
		    if(yd[i]>(double)ymax) ymax = (int)(yd[i]+.99)  ;
		    if(zd[i]<(double)zmin) zmin = (int)zd[i]  ;
		    if(zd[i]>(double)zmax) zmax = (int)(zd[i]+.99)  ;
		}
	
	if(ikk==0)
	    for(int i=0;i<n;i++)
		{
		    if(xg[i]<xmin) xmin = xg[i];
		    if(yg[i]<ymin) ymin = yg[i];
		    if(xg[i]>xmax) xmax = xg[i];
		    if(yg[i]>ymax) ymax = yg[i];
		}
    }

    public void moveobj(int xx,int yy)
    {
	for(int i=0;i<n;i++)
	    {
		if(ikk==0)
		    {
			xg[i] += xx;
			yg[i] += yy;
		    }
		if(ikk==1)
		    {
			xd[i] += (double)xx;
			yd[i] += (double)yy;
		    }
	    }
	setminmax();
    }

    public void movepoint(int xx,int yy)
    {
	if(select>1)
	    {
		if(ikk==0)
		    {
		xg[select-2] += xx;
		yg[select-2] += yy;
		    }
		if(ikk==1)
		    {
		xd[select-2] += (double)xx;
		yd[select-2] += (double)yy;
		    }
	    }
	if(select==1 && ikk==0)
	    for(int i=0;i<n;i++) {xg[i] += xx; yg[i] += yy;}
	if(select==1 && ikk==1)
	    for(int i=0;i<n;i++) {xd[i] += (double)xx; yd[i] += (double)yy;}
	setminmax();
    }

    public boolean selectpoint(int xx,int yy)
    {
	for(int i=0;i<n;i++)
	    {
		if(xx-(int)xd[i]<3 && xx-(int)xd[i]>-3 && yy-(int)yd[i]<3 && yy-(int)yd[i]>-3)
		    {
			select = i+2;
			return(true);
		    }
	    }
	return(false);
    }

    public boolean selectobj(int xx,int yy)
    {
	if(xx>=xmin && xx<=xmax && yy>=ymin && yy<=ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public void addpoint(int xx,int yy)
    {
	xg[n] = xx;
	yg[n] = yy;
	select = n+2;
	n++;
	setminmax();
    }


    public boolean done()
    {
      if(xg[n-1]==xg[n-2] && yg[n-1]==yg[n-2])
	{
	  n--;
		return(true);
	}
      return(false);
    }
}
