import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;
import java.awt.event.*;
import java.awt.Graphics2D.* ;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;
import javax.swing.border.*;
import java.awt.Color.*;
import javax.swing.plaf.*;
import java.util.*;
import java.awt.image.*;
import java.awt.image.Raster.*;
import javax.swing.text.*;
import java.lang.String.*;

//********************************************************************

class nubj_spline extends nubj implements Cloneable

//********************************************************************
{
  Color c;
  int n, ns, ikk=0;
  float xgg[] = new float[10];
  float ygg[] = new float[10];
  int xs[] = new int[128];
  int ys[] = new int[128];
  float xds[]= new float[500];
  float yds[]= new float[500];
  nubj_spline(int xx0,int yy0,Color cc,nubj_list p)
    {
      super(p);
	Color cl=cc;
	xs[0] = xs[1] = xmin = xmax = xx0;
	ys[0] = ys[1] = ymin = ymax = yy0;
	n = 2;
	select = 3;
    }

    public void transform(double xc, double yc, double zc)
    {
	ikk=1; n=101;
	for(int i=0;i<n;i++){xd[i]=(double)xds[i];yd[i]=(double)yds[i];}
	modi(xc,yc,zc,n);
	for(int i=0;i<n;i++){xds[i]=(float)xd[i];yds[i]=(float)yd[i];}
    }

    public void paint(Graphics g) 
    {

    }
    

    public void metapost(BufferedWriter out) 
    {
	float cr=0f, cv=0f, ca=0f, rc=0f, vc=0f, ac=0f;
	
	if(c!=null)
	    {
		cr = (float)c.getRed()/255f;
		cv = (float)c.getGreen()/255f;
		ca = (float)c.getBlue()/255f;
	    }
	rc = (float) cl.getRed()/255f;
	vc = (float) cl.getGreen()/255f;
	ac = (float) cl.getBlue()/255f;

	//       	for(int i=0;i<101;i++){ yd[i]=(double)(1180f-yds[i]/uesc);xd[i]=(double)(xds[i]/uesc); }
	//       	if(Math.abs(xd[n-1]-xd[0]) <=2 && Math.abs(yd[n-1]-yd[0]) <=2){xd[n-1]=xd[0]; yd[n-1]=yd[0];}
	try 
	    {
		if(refill==1) out.write ("col:= ("+cr+","+cv+","+ca+");\n");
		if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0) out.write ("loc:=("+rc+","+vc+","+ac+");\n");
		drw = "draw";
		if(putarr == true)
		    {
			if((numarr/100000) == 1) out.write("input fl_metap.mp;\n");
			if((numarr/100000) == 2) out.write("input fl_pstri.mp;\n");
			if((numarr/100000) == 3) out.write("input fl_simple.mp;\n");
			if((numarr/100000) == 4) out.write("input fl_open.mp;\n");
			if((numarr/100000) == 5) out.write("input fl_ugly.mp;\n");
			if((numarr/100000) == 6) out.write("input fl_guindi.mp;\n");
			if((numarr/10000)%10 == 1) out.write("ahlength:= 3 pt;\n");
		        if((numarr/10000)%10 == 2)out.write("ahlength:= 5 pt;\n");
		       	if((numarr/10000)%10 == 3)out.write("ahlength:= 7 pt;\n");
       		        if((numarr/10000)%10 == 4)out.write("ahlength:= 9 pt;\n");
	      		if((numarr/10000)%10 == 5)out.write("ahlength:= 13 pt;\n");
	      		if((numarr/10000)%10 == 6)out.write("ahlength:= 20 pt;\n");
			if((numarr/1000)%10 == 1) out.write("ahangle:= 20;\n");
			if((numarr/1000)%10 == 2) out.write("ahangle:= 30;\n");
			if((numarr/1000)%10 == 3) out.write("ahangle:= 45;\n");
			if((numarr/1000)%10 == 4) out.write("ahangle:= 60;\n");
			if((numarr/1000)%10 == 5) out.write("ahangle:= 75;\n");
			if((numarr/1000)%10 == 6) out.write("ahangle:= 90;\n");
			if((numarr/100)%10 == 1) out.write("linejoin:= rounded;\n");
			if((numarr/100)%10 == 2) out.write("linejoin:= mitered;\n");
			if((numarr)%10 == 1 && filar==false) drw = "drawarrow";
			if((numarr)%10 == 2 && filar==false) drw = "drawarrow reverse";
			if((numarr/10)%10 == 2 && filar==false) drw = "drawdblarrow";
			if((numarr)%10 == 1 && filar==true) drw = "drawwhitearrow";
			if((numarr)%10 == 2 && filar==true) drw = "drawwhitearrow reverse";
			if((numarr/10)%10 == 2 && filar==true) drw = "drawdblwharrow";
		    
		    }

		out.write("pickup pencircle scaled "+thickness+";\npath a;\na:=");   
		out.write("("+xds[0]+"u,"+(1180f-yds[0])+"u) -- ("+xds[1]+"u,"+(1180f-yds[1])+"u)");

		for(int i=2; i < 101; i++) out.write(" -- ("+xds[i]+"u,"+(1180f-yds[i])+"u)");

out.write(";\n");
		if(refill==1 && flag!=true)out.write("path b;\nb:= a -- cycle;\n");

		if(text_on_path==false)
		    {
			if(refill==1 && flag!=true) out.write( "fill b withcolor col;\n" );
			else if(refill==1) out.write("fill a withcolor col;\n");
			if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0)
		        out.write(drw+" a withcolor loc ");
			else out.write(drw+" a ");
			if(linea!=0)out.write(tipo_linea);
			else out.write(";\n");
		    }

		if(text_on_path==true)
		    {
			String colorli="black";
			if(partx[9]==1.0)colorli="red";
			if(partx[9]==2.0)colorli="green";
			if(partx[9]==3.0)colorli="blue";
			out.write("xscal:="+partx[1]+"; yscal:="+partx[2]+"; slan:="+partx[3]+"; scafig:="+partx[4]+"; hy:="+partx[5]+"; tt:="+partx[6]+"; sep:="+partx[7]+"; llc:="+colorli+"; lin:="+partx[10]+";\n");
			out.write("txp(ss,a,xscal,yscal,slan,scafig,hy,tt,sep,col,llc,lin,alt);\n");
		    }
	    }
	catch (IOException ex) { }            
    }

    public void setminmax()
    {
	xmin = 2000;
	ymin = 2000;
	xmax = -2000;
	ymax = -2000;
	zmax = -2000;
	zmin = 2000;
	if(ikk==0 && n<4)
	    for(int i=0;i<n;i++)
		{
		    if(xs[i]<xmin) xmin = xs[i];
		    if(ys[i]<ymin) ymin = ys[i];
		    if(xs[i]>xmax) xmax = xs[i];
		    if(ys[i]>ymax) ymax = ys[i];
		}
	else		
	    for(int i=0;i<101;i++)
		{
		    if(xds[i]<(float)xmin) xmin = (int)xds[i]  ;
		    if(yds[i]<(float)ymin) ymin = (int)yds[i]  ;
		    if(xds[i]>(float)xmax) xmax = (int)(xds[i]+.99)  ;
		    if(yds[i]>(float)ymax) ymax = (int)(yds[i]+.99)  ;
		    if(zd[i]<(double)zmin) zmin = (int)zd[i]  ;
		    if(zd[i]>(double)zmax) zmax = (int)(zd[i]+.99)  ;
		}
    }

    public void moveobj(int xx,int yy)
    {
      	    if(ikk==0)
		{
		    for(int i=0;i<n;i++){
		    xs[i] += xx;
		    ys[i] += yy;}
		}
	    else
		{
		    for(int i=0;i<101;i++){
		    xd[i] += (float)xx;
		    yd[i] += (float)yy;}
	      	}
	setminmax();
    }
    
    public void movepoint(int xx,int yy)
    {
	if(select>1)
	    {
		if(ikk==0)
		    {
		xs[select-2] += xx;
		ys[select-2] += yy;
		    }
	    }
	if(select==1 && ikk==0)
	    for(int i=0;i<n;i++) {xs[i] += xx; ys[i] += yy;}
	setminmax();
    }

    public boolean selectpoint(int xx,int yy)
    {
	for(int i=0;i<n;i++)
	    {
		if(xx-xs[i]<3 && xx-xs[i]>-3 && yy-ys[i]<3 && yy-ys[i]>-3)
		    {
			select = i+2;
			return(true);
		    }
	    }
	return(false);
    }

    public boolean selectobj(int xx,int yy)
    {
	if(xx>=xmin && xx<=xmax && yy>=ymin && yy<=ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public void addpoint(int xx,int yy)
    {
	xs[n] = xx;
	ys[n] = yy;
	select = n+2;
	n++;
	setminmax();
    }


    public boolean done()
    {
      if(xs[n-1]==xs[n-2] && ys[n-1]==ys[n-2])
	{
	  n--;
		return(true);
	}
      return(false);
    }
}
