import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;
import java.awt.event.*;
import java.awt.Graphics2D.* ;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;
import javax.swing.border.*;
import java.awt.Color.*;
import javax.swing.plaf.*;
import java.util.*;
import java.awt.image.*;
import java.awt.image.Raster.*;
import javax.swing.text.*;
import java.lang.String.*;

//***********************************************************************

class nubj_texto extends nubj

//***********************************************************************
{

    double angulo=0, texscal=1 ;
    Color c;
    int x0,y0,x1,y1,z0,z1;
    int esy=1180;
    int n, ikk=0;
    String letra = null;
    nubj_texto(int xx0,int yy0,Color cc,nubj_list p,String itexto)
    {
	super(p);
	x0 = x1 = xmin = xmax = xx0;
	y0 = y1 = ymin = ymax = yy0;
	n = 2;
	texto=itexto;
	select = 3;
    }

    nubj_texto(int xx0,int yy0,int xx1,int yy1,Color cc,nubj_list p,String itexto)
    {
	super(p);
	x0 =  xmin = xx0;
	y0 = ymin = yy0;
	x1 =  xmax = xx1;
	y1 =  ymax = yy1;
	n = 2;
	texto=itexto;
	select = 3;
    }

    public void newfont(String ifont)
    {
	letra = ifont;
    }

    public void transform(double xc, double yc, double zc)
    {
      	if(value==0 || value==1 || value==2 || value==3 || value==5 || value==6 || value==9 || value==11 || value==12 || value==13 || value==14)
	    {
		aviso.mostrar(true);
	    }
      	else  
	    ikk=1;
	modi(xc,yc,zc,n);
	T =(float)0.0;
    	texscal=es;
	if(value==7)xscal=(float)(texscal/100);
	if(value==8)yscal=(float)(texscal/100);
	if(value==10){xscal=(float)(texscal/100);yscal=xscal;}
	if(value==4)T=(float)(es/100);
    }

    public void paint(Graphics g) 
    {
	c = cc;
	Graphics2D g2 = (Graphics2D) g ;
	CSD = false;
	if(ikk==0){xd[0]=(double)x0;xd[1]=(double)x1;yd[0]=(double)y0;yd[1]=(double)y1;}
	setminmax();
	xc = (xd[0]+xd[1])/2;
	yc = (yd[0]+yd[1])/2;
	zc = (zd[0]+zd[1])/2;
	int x = (int)xd[0];
	int y = (int)yd[0];
	if(x>(int)xd[1]) x = (int)xd[1];
	if(y>(int)yd[1]) y = (int)yd[1];

	float strokeThickness = 1.0f*thickness;
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);

	if(select!=0)
      	    {
		g.setColor(Color.red);
		g.drawLine(x0,y0,x1,y1);
		g.fillRect(x0-1,y0-1,3,3);
		g.fillRect(x1-1,y1-1,3,3);
	    }
	else
	    {
		g.setColor(cl);
		g.drawLine(x0,y0,x1,y1);
		angulo = Math.atan2((double)(y1-y0),(double)(x1-x0)) ;
		g2.rotate(angulo,x0,y0);
		g2.drawString(texto,x0,y0);
		g2.rotate(-angulo,x0,y0);
	    }
	g.setColor(cl);
    }

    public void metapost(BufferedWriter out) 
    { 
      	float rc = (float) cl.getRed()/255f;
	float vc = (float) cl.getGreen()/255f;
	float ac = (float) cl.getBlue()/255f;
	try {
	    int ny0 = (int)(1180-y0/uesc);
	    if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0) out.write ("col:=("+rc+","+vc+","+ac+");\n");
	    else out.write("col:=(0,0,0);\n");

	    if(!text_on_path )
		{
	      	    if(letra==null) out.write("picture p;\np:=thelabel(btex "+texto+" etex , (0,0));\ndraw p xscaled "+xscal+" yscaled "+yscal+" slanted "+T+" rotated "+(float)(angulo*(-180)/3.1416)+" shifted ("+(x0/uesc)+"u,"+ny0+"u) withcolor col;\n");
		    else   out.write("\nprologues:=2;\npicture p;\ndefaultfont:=\""+letra+"\";\np:=thelabel(\""+texto+"\" , (0,0));\ndraw p xscaled "+xscal+" yscaled "+yscal+" slanted "+T+" rotated "+(float)(angulo*(-180)/(float)pi)+" shifted ("+(x0/uesc)+"u,"+ny0+"u) withcolor col;\nprologues:=0;\n");
		    //prologues:=0;\np:=thelabel(btex etex , ("+(x0/uesc)+"u,"+ny0+"u));\ndraw p;\n");
		}

	    if(text_on_path)
		{
		    out.write("color llc;\ninput fonts/txp;\nxscal:=1; yscal:=1; slan:=0; scafig:=1; hy:=-3.0; tt:=0.0; sep:=0.0; lin:=0.0;\nstring ss;\n");
    		    if(letra!="")out.write("input fonts/f"+letra+";\ndefaultfont:=\""+letra+"\";\n");
		    out.write("ss:=\""+texto+"\";\n");
		}
	}
	catch (IOException ex) { }
    }

    public void setminmax()
    {
	xmin = 2000;
	ymin = 2000;
	xmax = -2000;
	ymax = -2000;
	zmax = -2000;
	zmin = 2000;
	for(int i=0;i<2;i++)

	    {
		if(xd[i]<(double)xmin) xmin = (int)xd[i]  ;
		if(yd[i]<(double)ymin) ymin = (int)yd[i]  ;
		if(xd[i]>(double)xmax) xmax = (int)(xd[i]+.99)  ;
		if(yd[i]>(double)ymax) ymax = (int)(yd[i]+.99)  ;
		if(zd[i]<(double)zmin) zmin = (int)zd[i]  ;
		if(zd[i]>(double)zmax) zmax = (int)(zd[i]+.99)  ;
	    }
    }
    
    public void moveobj(int x,int y)
    {
	x1 += x;
	x0 += x;
	y1 += y;
	y0 += y;
	if(x0<x1) { xmin = x0 ; xmax = x1 ; }
	else      { xmin = x1 ; xmax = x0 ; }
	if(y0<y1) { ymin = y0 ; ymax = y1 ; }
	else      { ymin = y1 ; ymax = y0 ; }
    }

    public void movepoint(int x,int y)
    {
	if(select==2)
	    {
		x0 += x;
		y0 += y;
	    }
	if(select==3)
	    {
		x1 += x;
		y1 += y;
	    }
	if(x0<x1) { xmin = x0 ; xmax = x1 ; }
	else      { xmin = x1 ; xmax = x0 ; }
	if(y0<y1) { ymin = y0 ; ymax = y1 ; }
	else      { ymin = y1 ; ymax = y0 ; }
    }

    public boolean selectpoint(int x,int y)
    {
	if(x-x0<3 && x-x0>-3 && y-y0<3 && y-y0>-3)
	    {
		select = 2;
		return(true);
	    }
	else if(x-x1<3 && x-x1>-3 && y-y1<3 && y-y1>-3)
	    {
		select = 3;
		return(true);
	    }
	return(false);
    }

    public boolean selectobj(int x,int y)
    {
	if(x>=xmin && x<=xmax && y>=ymin && y<=ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<x0 && xx1>x1 && yy0<y0 && yy1>y1)
	    {
		select = 1;
		return(true);
	    }
	return(false);
	}
}

