import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;
import java.awt.event.*;
import java.awt.Graphics2D.* ;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;
import javax.swing.border.*;
import java.awt.Color.*;
import javax.swing.plaf.*;
import java.util.*;
import java.awt.image.*;
import java.awt.image.Raster.*;
import javax.swing.text.*;
import java.lang.String.*;


class nubj_list extends Object implements Serializable, Cloneable
{
    nubj ghead,gtail;
    nubj_list()
    {
	ghead = null;
	gtail = null;
    }
    
    public Object clone() 
    {
	nubj_list blist = new nubj_list();
	try {
	    blist = (nubj_list)super.clone();
	    return (Object) blist;
	} 
	catch (CloneNotSupportedException e) {throw new InternalError();}
    }  
}

public class nubj extends Object implements Serializable, Cloneable
{
    nubj next,prev;
    String nombre = new String(" ");
    public Aviso aviso = new Aviso();
    int select;
    int stat,iar=0,espi=1, sentido=0;
    float xscal=1f, yscal=1f;
    final double pi = Math.PI;
    int n, kk=0, change=0, inof=0;
    int grid=1;
    int value=0;
    int refill, numarr, linea=0;
    int xg[] = new int[1024];
    int yg[] = new int[1024];
    int zg[] = new int[1024];
    double xd[] = new double[1024];
    double yd[] = new double[1024];
    double zd[] = new double[1024];
    float pix[] = new float[512];
    float partx[] = new float[512];
    int xmin,ymin,xmax,ymax,zmin,zmax;
    Color cc = null;
    Color cl = Color.black;
    float thickness=0.5f;
    static float cte = 0.5528f;
    static double es = 1.0, n1=0.0, n2=0.0, n3=0.0, beta=0.0, nx1=0.0, nx2=0.0, nx3=0.0, XX0=0.0, YY0=0.0, ZZ0=0.0;
    static double xc,yc,zc,r,a11,a12,a13,a14,a21,a22,a23,a24,a31,a32,a33,a34,a41,a42,a43,a44,tet21,abtet21,teta;
    float dash[] = {5f}, T=0;
    String tipo_linea, type="", drw = "draw", texto=""; 
    boolean filar=false, dar=false, text_on_path = false, putarr = true, CSD = false, unir=false, gru=false, flag=false;
    static boolean crp=false;
    static Shape forma[];
    static{forma = new Shape[10];}
    static int uesc = 1;

    nubj_list parent;

    nubj(nubj_list p)
    {
	link(p);
    }

    public void link(nubj_list p)
    {
	next = null;
	prev = p.gtail;
	parent = p;
	if(p.ghead==null)
	    p.ghead = this;
	else
	    p.gtail.next = this;
	p.gtail = this;
    }

    public void modi(double xc, double yc, double zc, int nn)
    {
	double x, y, z;
	int n = nn;
	if(value==14){ xc=XX0; yc=YY0; zc=ZZ0; }
	for(int i=0;i<n;i++)
	    {
		xd[i]=xd[i]-xc; yd[i]=yd[i]-yc; zd[i]=zd[i]-zc;
		x = (a11*xd[i]+a21*yd[i]+a31*zd[i]+a41)/(a14*xd[i]+a24*yd[i]+a34*zd[i]+a44);
		y = (a12*xd[i]+a22*yd[i]+a32*zd[i]+a42)/(a14*xd[i]+a24*yd[i]+a34*zd[i]+a44);
		z = (a13*xd[i]+a23*yd[i]+a33*zd[i]+a43)/(a14*xd[i]+a24*yd[i]+a34*zd[i]+a44);
		xd[i]=x+xc; yd[i]=y+yc; zd[i]=z+zc;
		xg[i]=(int)(xd[i]+.49); yg[i]=(int)(yd[i]+.49); zg[i]=(int)(zd[i]+0.49);
	    }
    }


    public Object clone() 
    {
	try {
	    nubj ob=(nubj)super.clone();
	    ob.xg = (int[])xg.clone();
	    ob.yg = (int[])yg.clone();
	    ob.zg = (int[])zg.clone();
	    ob.xd = (double[])xd.clone();
	    ob.yd = (double[])yd.clone();
	    ob.zd = (double[])zd.clone();	    
	    return (Object)ob;
	} 
	catch (CloneNotSupportedException e) { throw new InternalError(); }
    }
    
    public void setFill(int ifill)
    {
	refill=ifill;
    }

    public void gtPix(int a, int b)
    {
	int corx,cory;
	corx=a; cory=b;
    }

    public void newarrow()
    {
    }

    public void newpartx(float[] txpar)
    {
	partx = txpar;
    }
    public void newfont(String ifont)
    {
	type = ifont;
    }

    static public void newAttachPoint()
    {
    }

    public void setnewtext(boolean itext_path)
    {
	text_on_path = itext_path;
    }

   public void setnewvalue(int irot)
    {
	value = irot;
    }

    public void changeCoor(int exchange)
    {
	int i=0; double screenx[]=new double[64]; double screeny[]=new double[64];
	double screenz[]=new double[64];
	change = exchange;

	if(change==1)// Plano XZ
	    {	 
		for(i=0;i<64;i++) 
		    {
			if(inof==0)
			    {
				screeny[i]=yd[i];
				screenz[i]=zd[i];
				yd[i]=screenz[i];
				zd[i]=screeny[i];
			    }
			
			if(inof==2)
			    {
				screenx[i]=zd[i];
				screeny[i]=yd[i];
				screenz[i]=xd[i];
				xd[i]=screenx[i];
				yd[i]=screenz[i];
				zd[i]=screeny[i];
			    }
		    }
		inof=change;
	    }
	
	if(change==2)// Plano ZY
	    {	 
		for(i=0;i<64;i++) 
		    {
			if(inof==0)
			    {
				screenx[i]=xd[i];
				screenz[i]=zd[i];
				xd[i]=screenz[i];
				zd[i]=screenx[i];
			    }
			
			if(inof==1)
			    {
				screenx[i]=xd[i];
				screeny[i]=zd[i];
				screenz[i]=yd[i];
				xd[i]=screenz[i];
				yd[i]=screeny[i];
				zd[i]=screenx[i];
			    }
		    }
		inof=change;
	    }
	
	if(change==0)// Plano XY
	    {	 
		for(i=0;i<64;i++) 
		    {
			if(inof==1)
			    {
				screeny[i]=zd[i];
				screenz[i]=yd[i];
				yd[i]=screeny[i];
				zd[i]=screenz[i];
			    }
			
			if(inof==2)
			    {
				screenx[i]=zd[i];
				screenz[i]=xd[i];
				xd[i]=screenx[i];
				zd[i]=screenz[i];
			    }
		    }
		inof=change;
	    }

    }
    
    public void setnewlinea(int jlin)
    {
	linea = jlin;
	if(linea==0)tipo_linea="";
	if(linea==1){
	    thickness *=2;
	    tipo_linea=" dashed withdots;\n";}
	if(linea==2)tipo_linea=" dashed evenly scaled 0.5;\n";
	if(linea==3)tipo_linea=" dashed evenly scaled 1;\n";
	if(linea==4)tipo_linea=" dashed evenly scaled 1.5;\n";
	if(linea==5)tipo_linea=" dashed evenly scaled 3;\n";
	if(linea==6)tipo_linea=" dashed evenly scaled 6;\n";
    }

    public void setEscal(double iesc)
    {
	es=iesc;
	a11=0; a12=0; a13=0; a14=0; a21=0; a22=0; a23=0; a24=0; a31=0; a32=0; a33=0; a34=0; a41=0; a42=0; a43=0; a44=0;
	
	if(value==1)     //traslacin segn eje X
	    {
		a11=1; a22=1; a33=1; a44=1; a41=es; 
	    }
	if(value==2)     //traslacin segn eje Y
	    {
		a11=1; a22=1; a33=1; a44=1; a42=es; 
	    }
	if(value==3)     //traslacin segn eje Z
	    {
		a11=1; a22=1; a33=1; a44=1; a43=es; 
	    }
	if(value==4)     //cizalladura segn eje X
	    {
		a11=1; a21=es/100; a31=a21; a22=1; a33=1; a44=1;
	    }
	if(value==5)     //cizalladura segn eje Y
	    {
		a11=1; a12=es/100; a32=a12; a22=1; a33=1; a44=1;
	    }
	if(value==6)     //cizalladura segn eje Z
	    {
		a11=1; a13=es/100; a23=a13; a22=1; a33=1; a44=1;
	    }
	if(value==7)     //escalamiento segn eje X
	    {
		a11=es/100; a22=1; a33=1; a44=1;
	    }
	if(value==8)     //escalamiento segn eje Y
	    {
		a11=1; a22=es/100; a33=1; a44=1;
	    }
	if(value==9)     //escalamiento segn eje Z
	    {
		a11=1; a22=1; a33=es/100; a44=1;
	    }
	if(value==10)     //escalamiento general
	    {
		a11=1; a22=1; a33=1; a44=(1000/es)/10;
	    } 
	if(value==11)     //giro segn eje X
	    {
		n1=1.0; n2=0.0; n3=0.0;
		giro(es);
	    }
	if(value==12)     //giro segn eje Y
	    {
		n1=0.0; n2=1.0; n3=0.0;
		giro(es);
	    }
	if(value==13)    //giro segn eje Z
	    {
		n1=0.0; n2=0.0; n3=1.0;
		giro(es);
	    }       
	if(value==14)    //giro sobre cualquier Eje
  	    {
		n1=nx1; n2=nx2; n3=nx3;
		giro(es);
  	    }
    }    
    public void giro(double angle)
    {
	beta=angle*pi/180.0;
	a11=n1*n1+(1-n1*n1)*Math.cos(beta);
	a12=n1*n2*(1-Math.cos(beta))+n3*Math.sin(beta);
	a13=n1*n3*(1-Math.cos(beta))-n2*Math.sin(beta); a14=0.0;
	a21=n1*n2*(1-Math.cos(beta))-n3*Math.sin(beta);
	a22=n2*n2+(1-n2*n2)*Math.cos(beta);
	a23=n2*n3*(1-Math.cos(beta))+n1*Math.sin(beta); a24=0.0;
	a31=n1*n3*(1-Math.cos(beta))+n2*Math.sin(beta);
	a32=n2*n3*(1-Math.cos(beta))-n1*Math.sin(beta);
	a33=n3*n3+(1-n3*n3)*Math.cos(beta); a34=0.0; 
	a41=0.0; a42=0.0; a43=0.0; a44=1.0;
    }

    public void thick()
    {
	thickness *=1.5f;
	thickness = ((int)(thickness*100))/100f;
    }

    public void thin()
    {
	thickness /=1.5f;
	thickness = ((int)(thickness*100))/100f;
	if(thickness == 0) thickness = 0.1f;
    }

    public void setcurvtex(boolean icurtex)
    {
	text_on_path = icurtex;
    }

    public void setArrow(int numb, boolean putr, boolean llena)
    {
	numarr = numb;
	putarr = putr;
	filar = llena;
    }

    public void ungroup()
    {
    }

    public void create(double a, double b, double c)
    {
    }

    public boolean done()
    {
	return(true);
    }

    public void addpoint(int x,int y)
    {
    }

    public void unlink()
    {
	if(next==null)
	    parent.gtail = prev;
	else
	    next.prev = prev;

	if(prev==null)
	    parent.ghead = next;
	else
	    prev.next = next;
	next = null;
	prev = null;
    }

    public void setcolor(Color icc)
    {
	cc = icc;
    }

    public void copy()
    {
    }

    public void setcolorline(Color icl)
    {
	cl = icl;
    }

    public void transform(double xx, double yy, double zz)
    {
    }

    public void delete()
    {
	unlink();
    }

    public void paint(Graphics g) 
    {
    }

    public static void zooming(int ues)
    {
	uesc = ues;
    }

    public void metapost(BufferedWriter out) 
    {
    }

    public void moveobj(int x,int y)
    {
    }

    public void movepoint(int x,int y)
    {
    }

    public boolean selectpoint(int x,int y)
    {
	return(false);
    }

    public boolean selectobj(int x,int y)
    {
	return(false);
    }

    public boolean selectrect(int x0,int y0,int w,int h)
    {
	return(false);
    }

}


