import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;
import java.awt.event.*;
import java.awt.Graphics2D.* ;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;
import javax.swing.border.*;
import java.awt.Color.*;
import javax.swing.plaf.*;
import java.util.*;
import java.awt.image.*;
import java.awt.image.Raster.*;
import javax.swing.text.*;
import java.lang.String.*;

//***********************************************************************

class nubj_circ extends nubj

//***********************************************************************
{
    Color c;
    public int n, teta1, teta2, teta21, R;
    public double R1, tet1, tet2, tet21;
    nubj_circ(int xx0,int yy0,Color cc,nubj_list p)
    {
	super(p);
	xg[0] = xg[1] = xmin = xmax = xx0;
	yg[0] = yg[1] = ymin = ymax = yy0;
	n = 2;
	select = 3;
    }

    public void transform(double xc, double yc, double zc)
    {
	if(value!=0) modi(xc,yc,zc,4);
	for(int i=0;i<n;i++){xg[i]=(int)xd[i];yg[i]=(int)yd[i];}
    }

    public void paint(Graphics g) 
    {
	c=cc;
	int ik=0;
	Graphics2D g2 = (Graphics2D) g ;
	CSD = false;
	float strokeThickness = thickness;
	if(select!=0)g2.drawString("   "+thickness,843,270);
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);
	g.setColor(c);
	Polygon p = new Polygon();
	for(int i=0;i<n;i++){
	     p.addPoint(xg[i],yg[i]);
	     xd[i]=(double)xg[i];yd[i]=(double)yg[i];}
	xc=(double)xg[0]; yc=(double)yg[0]; zc=(double)zg[0];

	if(select!=0)
	    {
	      g.setColor(Color.red);
	      stroke = new BasicStroke(0.5f);
	      g2.setStroke(stroke);

		for(int i = 0;i<n;i++)
		    {
			if(i==1)
			    {
				g2.drawLine(xg[0],yg[0],xg[1],yg[1]);
				g.fillRect(xg[0]-1,yg[0]-1,3,3);
				g.fillRect(xg[1]-1,yg[1]-1,3,3);
			    }
			if(i==2)
			    {
				g2.drawLine(xg[0],yg[0],xg[2],yg[2]);
				g.fillRect(xg[2]-1,yg[2]-1,3,3);
			    }
		    }
	    }
     
	if(select!=3)
	    {
		R1=Math.sqrt((xg[1]-xg[0])*(xg[1]-xg[0])+(yg[1]-yg[0])*(yg[1]-yg[0])); 
		R=(int)R1;
		tet1 = Math.atan2((double)(yg[0]-yg[1]),(double)(xg[1]-xg[0])) ; 
		teta1 =(int)(tet1*180d/pi + 0.49);
		tet2 = Math.atan2((double)(yg[0]-yg[2]),(double)(xg[2]-xg[0])) ;
		teta2 =(int)(tet2*180d/pi + 0.49);
		tet21=tet2-tet1;
		teta21=teta2-teta1;
		if((teta2<0 || teta2<teta1) && teta1>0)teta21= 360+teta2-teta1;
		else if(teta2<0 && teta2<teta1 && teta1<0)teta21= 360+teta2-teta1;
		r=R+R;
		g.setColor(cl);
		g.drawArc((xg[0]-R),(yg[0]-R), 2*R, 2*R, teta1, teta21);
	    }
	if(select==0)
	  {
	      stroke = new BasicStroke(thickness);
	      g2.setStroke(stroke);
	  }
		xg[3]=(int)(R1*Math.cos(tet2)+xg[0]+100*Math.cos(tet2));
		yg[3]=(int)(-R1*Math.sin(tet2)+yg[0]-100*Math.sin(tet2));
		xg[4]=(int)(R1*Math.cos(tet2)+xg[0]);
		yg[4]=(int)(-R1*Math.sin(tet2)+yg[0]);

		if(putarr == true)
		    {
		g.setColor(Color.blue);
			if((numarr/10)%10 == 1 && numarr%10 != 2) g.fillRect(xg[4]-1,yg[4]-1,3,3);
			if(numarr%10 == 2) g.fillRect(xg[1]-1,yg[1]-1,3,3);
			if((numarr/10)%10 == 2) 
			    {
				g.fillRect(xg[4]-1,yg[4]-1,3,3);
				g.fillRect(xg[1]-1,yg[1]-1,3,3);
			    }
		    }
		g.setColor(cl); 
	      stroke = new BasicStroke(0.5f);
	      g2.setStroke(stroke);
	    
    }
	
    public void metapost(BufferedWriter out) 
    {
	c=cc;
	float rc = (float) cl.getRed()/255f;
	float vc = (float) cl.getGreen()/255f;
	float ac = (float) cl.getBlue()/255f;
	try 
	    {
		drw = "draw";
		if(putarr == true)
		    {
			if((numarr/100000) == 1) out.write("input fl_metap.mp;\n");
			if((numarr/100000) == 2) out.write("input fl_pstri.mp;\n");
			if((numarr/100000) == 3) out.write("input fl_simple.mp;\n");
			if((numarr/100000) == 4) out.write("input fl_open.mp;\n");
			if((numarr/100000) == 5) out.write("input fl_ugly.mp;\n");
			if((numarr/100000) == 6) out.write("input fl_guindi.mp;\n");
			if((numarr/10000)%10 == 1) out.write("ahlength:= 3 pt;\n");
		        if((numarr/10000)%10 == 2)out.write("ahlength:= 5 pt;\n");
		       	if((numarr/10000)%10 == 3)out.write("ahlength:= 7 pt;\n");
       		        if((numarr/10000)%10 == 4)out.write("ahlength:= 9 pt;\n");
	      		if((numarr/10000)%10 == 5)out.write("ahlength:= 13 pt;\n");
	      		if((numarr/10000)%10 == 6)out.write("ahlength:= 20 pt;\n");
			if((numarr/1000)%10 == 1) out.write("ahangle:= 20;\n");
			if((numarr/1000)%10 == 2) out.write("ahangle:= 30;\n");
			if((numarr/1000)%10 == 3) out.write("ahangle:= 45;\n");
			if((numarr/1000)%10 == 4) out.write("ahangle:= 60;\n");
			if((numarr/1000)%10 == 5) out.write("ahangle:= 75;\n");
			if((numarr/1000)%10 == 6) out.write("ahangle:= 90;\n");
			if((numarr/100)%10 == 1) out.write("linejoin:= rounded;\n");
			if((numarr/100)%10 == 2) out.write("linejoin:= mitered;\n");
			if((numarr)%10 == 1 && filar==false) drw = "drawarrow";
			if((numarr)%10 == 2 && filar==false) drw = "drawarrow reverse";
			if((numarr/10)%10 == 2 && filar==false) drw = "drawdblarrow";
			if((numarr)%10 == 1 && filar==true) drw = "drawwhitearrow";
			if((numarr)%10 == 2 && filar==true) drw = "drawwhitearrow reverse";
			if((numarr/10)%10 == 2 && filar==true) drw = "drawdblwharrow";
		    
		    }

	        out.write("pickup pencircle scaled "+thickness+";\n");
		if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0)
			out.write ("loc:=("+rc+","+vc+","+ac+");\npath a, r, s;\n");
		else out.write ("loc:=(0.0,0.0,0.0);\npath a, r, s;\n");

	out.write("a:= fullcircle scaled "+(2*R1/uesc)+"u shifted ("+(xg[0]/uesc)+"u,"+(1180-yg[0]/uesc)+"u) rotatedaround(("+(xg[0]/uesc)+"u,"+(1180-yg[0]/uesc)+"u),"+teta1+");\n");
	out.write("r:=("+xg[0]/uesc+"u,"+(1180-yg[0]/uesc)+"u)--("+xg[1]/uesc+"u,"+(1180-yg[1]/uesc)+"u);\n");

	out.write("s:=("+(xg[0]/uesc)+"u,"+(1180-yg[0]/uesc)+"u)--("+(xg[3]/uesc)+"u,"+(1180-yg[3]/uesc)+"u);\n");
	out.write("a:= a cutafter s cutbefore r;\n");

	if(text_on_path==false)
	    {
		out.write(drw+" a withcolor loc ");
		if(linea!=0)out.write(tipo_linea);
		else out.write(";\n");
	    }
		if(text_on_path==true)
		    {
			String colorli="black";
			if(partx[9]==1.0)colorli="red";
			if(partx[9]==2.0)colorli="green";
			if(partx[9]==3.0)colorli="blue";
			out.write("xscal:="+partx[1]+"; yscal:="+partx[2]+"; slan:="+partx[3]+"; scafig:="+partx[4]+"; hy:="+partx[5]+"; tt:="+partx[6]+"; sep:="+partx[7]+"; llc:="+colorli+"; lin:="+partx[10]+";\n");
			out.write("txp(ss,a,xscal,yscal,slan,scafig,hy,tt,sep,col,llc,lin,alt);\n");
		    }
 	    }
	
	catch (IOException ex) { }             
    }
    
    public void setminmax()
    {
	xmin = 1000;
	ymin = 1000;
	xmax = -1000;
	ymax = -1000;
	for(int i=0;i<3;i++)
	    {
		if(xg[i]<xmin) xmin = xg[i];
		if(yg[i]<ymin) ymin = yg[i];
		if(xg[i]>xmax) xmax = xg[i];
		if(yg[i]>ymax) ymax = yg[i];
	    }
    }

    public void moveobj(int xx,int yy)
    {
	for(int i=0;i<n;i++)
	    {
		xg[i] += xx;
		yg[i] += yy;
		xd[i] += (double)xx;
		yd[i] += (double)yy;
	    }
	setminmax();
    }

    public void movepoint(int xx,int yy)
    {
	if(select>1)
	    {
		xg[select-2] += xx;
		yg[select-2] += yy;
		xd[select-2] += (double)xx;
		yd[select-2] += (double)yy;
	    }
	setminmax();
    }

    public boolean selectpoint(int xx,int yy)
    {
	for(int i=0;i<n;i++)
	    { 
		if((xx-xg[i]<3 && xx-xg[i]>-3 && yy-yg[i]<3 && yy-yg[i]>-3) ||
		   (i==3 && xx-xg[i]<5 && xx-xg[i]>-5 && yy-yg[i]<5 && yy-yg[i]>-5))
		    {
			select = i+2;
			return(true);
		    }

	    }
	return(false);
    }

    public boolean selectobj(int xx,int yy)
    {
	if(xx>=xmin && xx<=xmax && yy>=ymin && yy<=ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public void addpoint(int xx,int yy)
    {
	xg[n] = xx;
	yg[n] = yy;
	select = n+2;
	n++;
	setminmax();
    }


    public boolean done()
    {
	if(xg[n-1]==xg[n-2] && yg[n-1]==yg[n-2])
	    {
		n--;
		return(true);
	    }
	return(false);
    }
}
