import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;
import java.awt.event.*;
import java.awt.Graphics2D.* ;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;
import javax.swing.border.*;
import java.awt.Color.*;
import javax.swing.plaf.*;
import java.util.*;
import java.awt.image.*;
import java.awt.image.Raster.*;
import javax.swing.text.*;
import java.lang.String.*;

//**************************************************************************

class nubj_image extends nubj

//**************************************************************************
{
    int x0,y0,x1,y1,w,h;
  static BufferedImage newfoto;

    nubj_image(int xx0,int yy0,BufferedImage foto,double wd,double hd,nubj_list p)
    {
	super(p);
	x0 = xmin = xmax = xx0;
	y0 = ymin = ymax = yy0;
	newfoto = foto;
	w = (int)wd;
       	x1 = xmax = x0+w;
	h = (int)hd;
       	y1 = ymax = y0+h;
	select = 1;
    }
    
    public void paint(Graphics g) 
    {
	Graphics2D g2 = (Graphics2D) g ;
	CSD = false;
	int x = x0;
	int y = y0;
	int w = x1-x0;
	int h = y1-y0;
	if(x>x1) x = x1;
	if(y>y1) y = y1;
	if(w<0) w = -w;
	if(h<0) h = -h;
	String ax0 = Integer.toString(x0);
	String ay0 = Integer.toString(y0);
	String aw0 = Integer.toString(w);
	String ah0 = Integer.toString(h);
	imatot.tbot3.setText(aw0);
	imatot.tbot4.setText(ah0);
	imatot.tbot5.setText(ax0);
	imatot.tbot6.setText(ay0);
       	imatot.dat=true;
	g2.setColor(cc);
	g2.drawImage(newfoto,null,x0,y0);
	if(select==1)
	    {
		g2.setColor(Color.red);
		g2.drawRect(x,y,w,h);
	    }
	g2.setColor(Color.black);
    }

    public void metapost(BufferedWriter out) 
    {
	try
	    {
		out.write("input dat_imag"+(imatot.imag)+";\n");
	    }
	catch(IOException ex){}
    } 

    public void moveobj(int x,int y)
    {
	x1 += x;
	x0 += x;
	y1 += y;
	y0 += y;
	xmin = x0; xmax = x1; 
	ymin = y0; ymax = y1; 
    }

     public void movepoint(int x,int y)
    {
		if(select==5 || select==3)
		    x1 += x;
		if(select==4 || select==2)
		    x0 += x;
		if(select==5 || select==4)
		    y1 += y;
		if(select==3 || select==2)
		    y0 += y;
		if(x0<x1) { xmin = x0 ; xmax = x1 ; }
		else      { xmin = x1 ; xmax = x0 ; }
		if(y0<y1) { ymin = y0 ; ymax = y1 ; }
		else      { ymin = y1 ; ymax = y0 ; }
    }

    public boolean selectpoint(int x,int y)
    {
	if(x-x0<3 && x-x0>-3 && y-y0<3 && y-y0>-3)
	    {
		select = 2;
		return(true);
	    }
	if(x-x1<3 && x-x1>-3 && y-y0<3 && y-y0>-3)
	    {
		select = 3;
		return(true);
	    }
	if(x-x0<3 && x-x0>-3 && y-y1<3 && y-y1>-3)
	    {
		select = 4;
		return(true);
	    }
	else if(x-x1<3 && x-x1>-3 && y-y1<3 && y-y1>-3)
	    {
		select = 5;
		return(true);
	    }
	return(false);
    }




   public boolean selectobj(int x,int y)
    {
	if(x>=xmin && x<=xmax && y>=ymin && y<=ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }
}
