import java.io.* ;
import java.awt.*;
import java.awt.geom.* ;
import java.awt.event.*;
import java.awt.Graphics2D.* ;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.colorchooser.*;
import javax.swing.border.*;
import java.awt.Color.*;
import javax.swing.plaf.*;
import java.util.*;
import java.awt.image.*;
import java.awt.image.Raster.*;
import javax.swing.text.*;
import java.lang.String.*;

//***********************************************************************

class nubj_oval extends nubj

//***********************************************************************
{
  Color c;
  int x0,y0,x1,y1,ijk=0,w,h;

  nubj_oval(int xx0,int yy0,Color cc,nubj_list p)
  {
    super(p);
    c = cc;
    nombre="ov";
    x0 = x1 = xmin = xmax = xx0;
    y0 = y1 = ymin = ymax = yy0;
    select = 5;
  }

  public void transform(double xc, double yc, double zc)
    {
	if(value!=10)ijk=ijk+1;
	if(value!=0) modi(xc,yc,zc,4);
	x0=(int)xd[0];
	x1=(int)xd[1];
	y0=(int)yd[0];
	y1=(int)yd[1];
    }

    public GeneralPath daForma(double px0, double px1, double px2, double px3, double py0, double py1, double py2, double py3)
    {
	float xx0=(float)px0, xx1=(float)px1, xx2=(float)px2, xx3=(float)px3, yy0=(float)py0, yy1=(float)py1, yy2=(float)py2, yy3=(float)py3;
	float x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11;
	float y0,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11;
	float wh=xx3-xx0; float wv=xx2-xx0; 
	float hh=yy0-yy3; float hv=yy2-yy0; 
	float xh=cte*wh/2; float xv=cte*wv/2;
	float yh=cte*hh/2; float yv=cte*hv/2;
	x0=(xx2+xx0)/2;x3=(xx0+xx3)/2;x6=(xx3+xx1)/2;x9=(xx1+xx2)/2;
	y0=(yy2+yy0)/2;y3=(yy0+yy3)/2;y6=(yy3+yy1)/2;y9=(yy1+yy2)/2;
	x1=x0-xv; x11=x0+xv; x5=x6-xv; x7=x6+xv; x2=x3-xh; x4=x3+xh; 
	x8=x9+xh; x10=x9-xh;
	y1=y0-yv; y11=y0+yv; y5=y6-yv; y7=y6+yv; y2=y3+yh; y4=y3-yh; 
	y8=y9-yh; y10=y9+yh;
	GeneralPath elipse = new GeneralPath();
	elipse.moveTo(x0,y0);
	elipse.curveTo(x1,y1,x2,y2,x3,y3);
	elipse.curveTo(x4,y4,x5,y5,x6,y6);
	elipse.curveTo(x7,y7,x8,y8,x9,y9);
	elipse.curveTo(x10,y10,x11,y11,x0,y0);
	return(elipse);
    }
    
    public void paint(Graphics g) 
    {
	Graphics2D g2 = (Graphics2D) g ;
	CSD = false;
	int x = x0;
	int y = y0;
	w = x1-x0;
	h = y1-y0;
	if(x>x1) x = x1;
	if(y>y1) y = y1;
	if(w<0) w = -w;
	if(h<0) h = -h;
	if(ijk==0)
	    {
	    if(x!=x1 && y!=y1){
	    xd[0]=(double)x;yd[0]=(double)y;xd[1]=(double)x1;yd[1]=(double)y1;
	    xd[2]=xd[0];yd[2]=yd[1];xd[3]=xd[1];yd[3]=yd[0];}
	    if(x==x1 && y==y1){
	    xd[0]=(double)x;yd[0]=(double)y;xd[1]=(double)x0;yd[1]=(double)y0;
	    xd[2]=xd[0];yd[2]=yd[1];xd[3]=xd[1];yd[3]=yd[0];}
	    if(x!=x1 && y==y1){
	    xd[0]=(double)x;yd[0]=(double)y;xd[1]=(double)x1;yd[1]=(double)y0;
	    xd[2]=xd[0];yd[2]=yd[1];xd[3]=xd[1];yd[3]=yd[0];}
	    if(x==x1 && y!=y1){
	    xd[0]=(double)x;yd[0]=(double)y;xd[1]=(double)x0;yd[1]=(double)y1;
	    xd[2]=xd[0];yd[2]=yd[1];xd[3]=xd[1];yd[3]=yd[0];}
	    }
	xc = (xd[0]+xd[1])/2;
	yc = (yd[0]+yd[1])/2;
	zc = (zd[0]+zd[1])/2;
	float strokeThickness = thickness;g.setColor(new Color(230,230,230));
	BasicStroke stroke = new BasicStroke(strokeThickness);
	g2.setStroke(stroke);
	GeneralPath elip = daForma(xd[0],xd[1],xd[2],xd[3],yd[0],yd[1],yd[2],yd[3]);
	forma[1] = (Shape) elip; 
	if (select != 0)
	{
	    g2.setColor(Color.red);
	    stroke = new BasicStroke(0.5f);
	    g2.setStroke(stroke);
	    if(ijk==0)
		{
		    g2.drawRect(x,y,w,h);
		    g2.fillRect(x-1,y-1,3,3);
		    g2.fillRect(x+w-1,y-1,3,3);
		    g2.fillRect(x-1,y+h-1,3,3);
		    g2.fillRect(x+w-1,y+h-1,3,3);
		}
	    g2.draw(forma[1]);
	}

	if (select == 0 )
	    {
		stroke = new BasicStroke(thickness);
		g2.setStroke(stroke);
		if(refill==1)
		    {
			g2.setColor(cc); 
			g2.fill(forma[1]);
		    }
		g2.setColor(cl);
		g2.draw(forma[1]);
	    }
	      stroke = new BasicStroke(0.5f);
	      g2.setStroke(stroke);
	g2.setColor(cl);
    }

    public void metapost (BufferedWriter out) 
    {
	float cr=0f, cv=0f, ca=0f, rc=0f, vc=0f, ac=0f;
	if(refill==1)
	    {
		cr = (float)cc.getRed()/255f;
		cv = (float)cc.getGreen()/255f;
		ca = (float)cc.getBlue()/255f;
	    }
	rc = (float) cl.getRed()/255f;
	vc = (float) cl.getGreen()/255f;
	ac = (float) cl.getBlue()/255f;
	try 
	    {
		if(refill==1) out.write ("col:= ("+cr+","+cv+","+ca+");\n");
		if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0) out.write ("loc:=("+rc+","+vc+","+ac+");\n");
		out.write("pickup pencircle scaled "+thickness+";\npath a;\na:=");
	

	float xx0=(float)(xd[0]/uesc), xx1=(float)(xd[1]/uesc), xx2=(float)(xd[2]/uesc), xx3=(float)(xd[3]/uesc), yy0=(float)(yd[0]/uesc), yy1=(float)(yd[1]/uesc), yy2=(float)(yd[2]/uesc), yy3=(float)(yd[3]/uesc);
	float x0,x1,x2,x3,x4,x5,x6,x7,x8,x9,x10,x11;
	float y0,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11;
	float wh=xx3-xx0; float wv=xx2-xx0; 
	float hh=yy0-yy3; float hv=yy2-yy0; 
	float xh=cte*wh/2; float xv=cte*wv/2;
	float yh=cte*hh/2; float yv=cte*hv/2;
	x0=(xx2+xx0)/2;x3=(xx0+xx3)/2;x6=(xx3+xx1)/2;x9=(xx1+xx2)/2;
	y0=(yy2+yy0)/2;y3=(yy0+yy3)/2;y6=(yy3+yy1)/2;y9=(yy1+yy2)/2;
	x1=x0-xv; x11=x0+xv; x5=x6-xv; x7=x6+xv; x2=x3-xh; x4=x3+xh; 
	x8=x9+xh; x10=x9-xh;
	y1=y0-yv; y11=y0+yv; y5=y6-yv; y7=y6+yv; y2=y3+yh; y4=y3-yh; 
	y8=y9-yh; y10=y9+yh;
	float ym1=1180f-y1;float ym2=1180f-y2;float ym3=1180f-y3;
	float ym4=1180f-y4;float ym5=1180f-y5;float ym6=1180f-y6;
	float ym7=1180f-y7;float ym8=1180f-y8;float ym9=1180f-y9;
	float ym10=1180f-y10;float ym11=1180f-y11;float ym0=1180f-y0;
	out.write("("+x0+"u,"+ym0+"u).. controls ("+x1+"u,"+ym1+"u) and ("+x2+"u,"+ym2+"u)..("+x3+"u,"+ym3+"u).. controls ("+x4+"u,"+ym4+"u) and ("+x5+"u,"+ym5+"u)..("+x6+"u,"+ym6+"u).. controls ("+x7+"u,"+ym7+"u) and ("+x8+"u,"+ym8+"u)..("+x9+"u,"+ym9+"u).. controls ("+x10+"u,"+ym10+"u) and ("+x11+"u,"+ym11+"u)..("+x0+"u,"+ym0+"u) .. cycle;\n");
		if(text_on_path==false)
		    {
			if(refill==1) out.write( "fill a withcolor col;\n" ); 
			if((int)(10f*rc)!=0 || (int)(10f*vc)!=0 || (int)(10f*ac)!=0)
			    {
				out.write("draw a withcolor loc ");
				if(linea!=0)out.write(tipo_linea);
				else out.write(";\n");
			    }
			else
			    {
				out.write("draw a ");
				if(linea!=0)out.write(tipo_linea);
				else out.write(";\n");
			    }
		    }
		if(text_on_path==true)
		    {
			String colorli="black";
			if(partx[9]==1.0)colorli="red";
			if(partx[9]==2.0)colorli="green";
			if(partx[9]==3.0)colorli="blue";
			out.write("xscal:="+partx[1]+"; yscal:="+partx[2]+"; slan:="+partx[3]+"; scafig:="+partx[4]+"; hy:="+partx[5]+"; tt:="+partx[6]+"; sep:="+partx[7]+"; llc:="+colorli+"; lin:="+partx[10]+";\n");
			out.write("txp(ss,a,xscal,yscal,slan,scafig,hy,tt,sep,col,llc,lin,alt);\n");
		    }
	    }
	catch (IOException ex) { }            
    }
    public void moveobj(int x,int y)
    {
	if(ijk==0)
	    {
		for(int i=0;i<4;i++)
		    {
			xd[i]+=(double)x;
			yd[i]+=(double)y; }
		x1 += x;
		x0 += x;
		y1 += y;
		y0 += y;
		if(x0<x1) { xmin = x0-2 ; xmax = x1+2 ; }
		else      { xmin = x1-2 ; xmax = x0+2 ; }
		if(y0<y1) { ymin = y0-2 ; ymax = y1+2 ; }
		else      { ymin = y1-2 ; ymax = y0+2 ; }
	    }
	if(ijk!=0)
	    {
		xmin=2000;xmax=-2000;ymin=2000;ymax=-2000;
		for(int i=0;i<4;i++)
		    {
			xd[i]+=(double)x;
			yd[i]+=(double)y;                       
			if(xmin>(int)xd[i]-1) xmin=(int)xd[i]-1;
			if(xmax<(int)xd[i]+1) xmax=(int)xd[i]+1;
			if(ymin>(int)yd[i]-1) ymin=(int)yd[i]-1;
			if(ymax<(int)yd[i]+1) ymax=(int)yd[i]+1;
		    }
	    }
    }
    public void movepoint(int x,int y)
    {
	if(ijk==0)
	    {
		if(select==5 || select==3)
		    x1 += x;
		if(select==4 || select==2)
		    x0 += x;
		if(select==5 || select==4)
		    y1 += y;
		if(select==3 || select==2)
		    y0 += y;
		if(x0<x1) { xmin = x0 ; xmax = x1 ; }
		else      { xmin = x1 ; xmax = x0 ; }
		if(y0<y1) { ymin = y0 ; ymax = y1 ; }
		else      { ymin = y1 ; ymax = y0 ; }
	    }

    }

    public boolean selectpoint(int x,int y)
    {
	if(x-x0<3 && x-x0>-3 && y-y0<3 && y-y0>-3)
	    {
		select = 2;
		return(true);
	    }
	if(x-x1<3 && x-x1>-3 && y-y0<3 && y-y0>-3)
	    {
		select = 3;
		return(true);
	    }
	if(x-x0<3 && x-x0>-3 && y-y1<3 && y-y1>-3)
	    {
		select = 4;
		return(true);
	    }
	else if(x-x1<3 && x-x1>-3 && y-y1<3 && y-y1>-3)
	    {
		select = 5;
		return(true);
	    }
	return(false);
    }

    public boolean selectobj(int x,int y)
    {
	if(x>=xmin && x<=xmax && y>=ymin && y<=ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }

    public boolean selectrect(int xx0,int yy0,int xx1,int yy1)
    {
	if(xx0<xmin && xx1>xmax && yy0<ymin && yy1>ymax)
	    {
		select = 1;
		return(true);
	    }
	return(false);
    }
}
